# Cloudbeds PMS V1.3
<p>     Welcome to the documentation for <strong>Cloudbeds API Version v1.3</strong>!     If you are looking to learn how to use the Cloudbeds API to access guest information, reservations, or similar data     for your Cloudbeds customers, then you've come to the right place. </p>  <p>     In this document you will find all the API methods we provide along with explanations for parameters and response     examples. </p>  <p>     If you have questions about different implementation steps (e.g. how to implement OAuth 2.0), please refer to our     <a href=\"https://integrations.cloudbeds.com/hc/en-us\">Integrations Portal</a>. </p>  <p>     Be sure to <a href=\"https://go.pardot.com/l/308041/2018-07-24/qb2lg\">subscribe</a> to the monthly     Cloudbeds API announcement mailing list to receive information on new additions and improvements to the     Cloudbeds API and related developer tools. </p>  <p>     <strong>Endpoint:</strong> https://api.cloudbeds.com/api/v1.3/{method} </p>  <p>     <strong>HTTPS:</strong> Our API requires HTTPS. We'll respond with an appropriate error if you're not using it. </p>  <p>     <strong>Request Format:</strong> HTTP GET, POST and PUT (Content-Type: application/x-www-form-urlencoded) </p>  <p>     <strong>Response Format:</strong> JSON </p>  <p>     <strong>Response Header:</strong> X-Request-ID is added to response headers in all calls to help accelerate support     and troubleshooting. </p>  <p>     <strong>         <a href=\"https://integrations.cloudbeds.com/hc/en-us/articles/14104678058267-API-Documentation#postman-collection\">             <img src=\"https://run.pstmn.io/button.svg\" alt=\"Run in Postman\">         </a>     </strong> use this link to access our Public collection in Postman. </p>

The `cloudbeds_pms_v1_3` package is automatically generated by the [OpenAPI Generator](https://openapi-generator.tech) project:

- API version: v1.3
- Package version: 1.0.0
- Generator version: 7.11.0
- Build package: org.openapitools.codegen.languages.PythonClientCodegen

## Requirements.

Python 3.8+

## Installation & Usage

This python library package is generated without supporting files like setup.py or requirements files

To be able to use it, you will need these dependencies in your own package that uses this library:

* urllib3 >= 1.25.3, < 3.0.0
* python-dateutil >= 2.8.2
* pydantic >= 2
* typing-extensions >= 4.7.1

## Getting Started

In your own code, to use this library to connect and interact with Cloudbeds PMS V1.3,
you can run the following:

```python

import cloudbeds_pms_v1_3
from cloudbeds_pms_v1_3.rest import ApiException
from pprint import pprint

# Defining the host is optional and defaults to https://api.cloudbeds.com/api/v1.3
# See configuration.py for a list of all supported configuration parameters.
configuration = cloudbeds_pms_v1_3.Configuration(
    host = "https://api.cloudbeds.com/api/v1.3"
)

# The client must configure the authentication and authorization parameters
# in accordance with the API server security policy.
# Examples for each auth method are provided below, use the example that
# satisfies your auth use case.

configuration.access_token = os.environ["ACCESS_TOKEN"]

# Configure API key authorization: api_key
configuration.api_key['api_key'] = os.environ["API_KEY"]

# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['api_key'] = 'Bearer'


# Enter a context with an instance of the API client
with cloudbeds_pms_v1_3.ApiClient(configuration) as api_client:
    # Create an instance of the API class
    api_instance = cloudbeds_pms_v1_3.AdjustmentApi(api_client)
    reservation_id = 'reservation_id_example' # str | Reservation identifier
    adjustment_id = 'adjustment_id_example' # str | Adjustment identifier
    property_id = 'property_id_example' # str | Property ID (optional)

    try:
        # deleteAdjustment
        api_response = api_instance.delete_adjustment_delete(reservation_id, adjustment_id, property_id=property_id)
        print("The response of AdjustmentApi->delete_adjustment_delete:\n")
        pprint(api_response)
    except ApiException as e:
        print("Exception when calling AdjustmentApi->delete_adjustment_delete: %s\n" % e)

```

## Documentation for API Endpoints

All URIs are relative to *https://api.cloudbeds.com/api/v1.3*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*AdjustmentApi* | [**delete_adjustment_delete**](cloudbeds_pms_v1_3/docs/AdjustmentApi.md#delete_adjustment_delete) | **DELETE** /deleteAdjustment | deleteAdjustment
*AdjustmentApi* | [**get_adjustment_get**](cloudbeds_pms_v1_3/docs/AdjustmentApi.md#get_adjustment_get) | **GET** /getAdjustment | getAdjustment
*AdjustmentApi* | [**get_adjustments_get**](cloudbeds_pms_v1_3/docs/AdjustmentApi.md#get_adjustments_get) | **GET** /getAdjustments | getAdjustments
*AdjustmentApi* | [**post_adjustment_post**](cloudbeds_pms_v1_3/docs/AdjustmentApi.md#post_adjustment_post) | **POST** /postAdjustment | postAdjustment
*AllotmentBlocksApi* | [**create_allotment_block_notes_post**](cloudbeds_pms_v1_3/docs/AllotmentBlocksApi.md#create_allotment_block_notes_post) | **POST** /createAllotmentBlockNotes | createAllotmentBlockNotes
*AllotmentBlocksApi* | [**create_allotment_block_post**](cloudbeds_pms_v1_3/docs/AllotmentBlocksApi.md#create_allotment_block_post) | **POST** /createAllotmentBlock | createAllotmentBlock
*AllotmentBlocksApi* | [**delete_allotment_block_post**](cloudbeds_pms_v1_3/docs/AllotmentBlocksApi.md#delete_allotment_block_post) | **POST** /deleteAllotmentBlock | deleteAllotmentBlock
*AllotmentBlocksApi* | [**get_allotment_blocks_get**](cloudbeds_pms_v1_3/docs/AllotmentBlocksApi.md#get_allotment_blocks_get) | **GET** /getAllotmentBlocks | getAllotmentBlocks
*AllotmentBlocksApi* | [**list_allotment_block_notes_get**](cloudbeds_pms_v1_3/docs/AllotmentBlocksApi.md#list_allotment_block_notes_get) | **GET** /listAllotmentBlockNotes | listAllotmentBlockNotes
*AllotmentBlocksApi* | [**update_allotment_block_notes_post**](cloudbeds_pms_v1_3/docs/AllotmentBlocksApi.md#update_allotment_block_notes_post) | **POST** /updateAllotmentBlockNotes | updateAllotmentBlockNotes
*AllotmentBlocksApi* | [**update_allotment_block_post**](cloudbeds_pms_v1_3/docs/AllotmentBlocksApi.md#update_allotment_block_post) | **POST** /updateAllotmentBlock | updateAllotmentBlock
*AppSettingsApi* | [**delete_app_property_settings_post**](cloudbeds_pms_v1_3/docs/AppSettingsApi.md#delete_app_property_settings_post) | **POST** /deleteAppPropertySettings | deleteAppPropertySettings
*AppSettingsApi* | [**get_app_property_settings_get**](cloudbeds_pms_v1_3/docs/AppSettingsApi.md#get_app_property_settings_get) | **GET** /getAppPropertySettings | getAppPropertySettings
*AppSettingsApi* | [**post_app_property_settings_post**](cloudbeds_pms_v1_3/docs/AppSettingsApi.md#post_app_property_settings_post) | **POST** /postAppPropertySettings | postAppPropertySettings
*AppSettingsApi* | [**post_bulk_app_property_settings_post**](cloudbeds_pms_v1_3/docs/AppSettingsApi.md#post_bulk_app_property_settings_post) | **POST** /postBulkAppPropertySettings | postBulkAppPropertySettings
*AppSettingsApi* | [**put_app_property_settings_post**](cloudbeds_pms_v1_3/docs/AppSettingsApi.md#put_app_property_settings_post) | **POST** /putAppPropertySettings | putAppPropertySettings
*AuthenticationApi* | [**access_token_check_post**](cloudbeds_pms_v1_3/docs/AuthenticationApi.md#access_token_check_post) | **POST** /access_token_check | access_token_check
*AuthenticationApi* | [**access_token_post**](cloudbeds_pms_v1_3/docs/AuthenticationApi.md#access_token_post) | **POST** /access_token | access_token
*AuthenticationApi* | [**oauth_metadata_get**](cloudbeds_pms_v1_3/docs/AuthenticationApi.md#oauth_metadata_get) | **GET** /oauth/metadata | metadata
*AuthenticationApi* | [**userinfo_get**](cloudbeds_pms_v1_3/docs/AuthenticationApi.md#userinfo_get) | **GET** /userinfo | userinfo
*BetaApi* | [**get_async_api_job_get**](cloudbeds_pms_v1_3/docs/BetaApi.md#get_async_api_job_get) | **GET** /getAsyncApiJob | getAsyncApiJob
*CRMApi* | [**crm_cache_remove_post**](cloudbeds_pms_v1_3/docs/CRMApi.md#crm_cache_remove_post) | **POST** /crm/cache_remove | PostCRMCacheRemove
*CRMApi* | [**crm_cache_update_post**](cloudbeds_pms_v1_3/docs/CRMApi.md#crm_cache_update_post) | **POST** /crm/cache_update | PostCRMCacheUpdate
*CurrencyApi* | [**get_currency_settings_get**](cloudbeds_pms_v1_3/docs/CurrencyApi.md#get_currency_settings_get) | **GET** /getCurrencySettings | getCurrencySettings
*CustomFieldsApi* | [**get_custom_fields_get**](cloudbeds_pms_v1_3/docs/CustomFieldsApi.md#get_custom_fields_get) | **GET** /getCustomFields | getCustomFields
*CustomFieldsApi* | [**post_custom_field_post**](cloudbeds_pms_v1_3/docs/CustomFieldsApi.md#post_custom_field_post) | **POST** /postCustomField | postCustomField
*DashboardApi* | [**get_dashboard_get**](cloudbeds_pms_v1_3/docs/DashboardApi.md#get_dashboard_get) | **GET** /getDashboard | getDashboard
*EmailsApi* | [**get_email_schedule_get**](cloudbeds_pms_v1_3/docs/EmailsApi.md#get_email_schedule_get) | **GET** /getEmailSchedule | getEmailSchedule
*EmailsApi* | [**get_email_templates_get**](cloudbeds_pms_v1_3/docs/EmailsApi.md#get_email_templates_get) | **GET** /getEmailTemplates | getEmailTemplates
*EmailsApi* | [**post_email_schedule_post**](cloudbeds_pms_v1_3/docs/EmailsApi.md#post_email_schedule_post) | **POST** /postEmailSchedule | postEmailSchedule
*EmailsApi* | [**post_email_template_post**](cloudbeds_pms_v1_3/docs/EmailsApi.md#post_email_template_post) | **POST** /postEmailTemplate | postEmailTemplate
*GroupsApi* | [**get_group_notes_get**](cloudbeds_pms_v1_3/docs/GroupsApi.md#get_group_notes_get) | **GET** /getGroupNotes | getGroupNotes
*GroupsApi* | [**get_groups_get**](cloudbeds_pms_v1_3/docs/GroupsApi.md#get_groups_get) | **GET** /getGroups | getGroups
*GroupsApi* | [**patch_group_post**](cloudbeds_pms_v1_3/docs/GroupsApi.md#patch_group_post) | **POST** /patchGroup | patchGroup
*GroupsApi* | [**post_group_note_post**](cloudbeds_pms_v1_3/docs/GroupsApi.md#post_group_note_post) | **POST** /postGroupNote | postGroupNote
*GroupsApi* | [**put_group_post**](cloudbeds_pms_v1_3/docs/GroupsApi.md#put_group_post) | **POST** /putGroup | putGroup
*GuestApi* | [**delete_guest_note_delete**](cloudbeds_pms_v1_3/docs/GuestApi.md#delete_guest_note_delete) | **DELETE** /deleteGuestNote | deleteGuestNote
*GuestApi* | [**get_guest_get**](cloudbeds_pms_v1_3/docs/GuestApi.md#get_guest_get) | **GET** /getGuest | getGuest
*GuestApi* | [**get_guest_list_get**](cloudbeds_pms_v1_3/docs/GuestApi.md#get_guest_list_get) | **GET** /getGuestList | getGuestList
*GuestApi* | [**get_guest_notes_get**](cloudbeds_pms_v1_3/docs/GuestApi.md#get_guest_notes_get) | **GET** /getGuestNotes | getGuestNotes
*GuestApi* | [**get_guests_by_filter_get**](cloudbeds_pms_v1_3/docs/GuestApi.md#get_guests_by_filter_get) | **GET** /getGuestsByFilter | getGuestsByFilter
*GuestApi* | [**get_guests_by_status_get**](cloudbeds_pms_v1_3/docs/GuestApi.md#get_guests_by_status_get) | **GET** /getGuestsByStatus | getGuestsByStatus
*GuestApi* | [**get_guests_modified_get**](cloudbeds_pms_v1_3/docs/GuestApi.md#get_guests_modified_get) | **GET** /getGuestsModified | getGuestsModified
*GuestApi* | [**post_guest_credit_card_post**](cloudbeds_pms_v1_3/docs/GuestApi.md#post_guest_credit_card_post) | **POST** /postGuestCreditCard | postGuestCreditCard
*GuestApi* | [**post_guest_document_post**](cloudbeds_pms_v1_3/docs/GuestApi.md#post_guest_document_post) | **POST** /postGuestDocument | postGuestDocument
*GuestApi* | [**post_guest_note_post**](cloudbeds_pms_v1_3/docs/GuestApi.md#post_guest_note_post) | **POST** /postGuestNote | postGuestNote
*GuestApi* | [**post_guest_photo_post**](cloudbeds_pms_v1_3/docs/GuestApi.md#post_guest_photo_post) | **POST** /postGuestPhoto | postGuestPhoto
*GuestApi* | [**post_guest_post**](cloudbeds_pms_v1_3/docs/GuestApi.md#post_guest_post) | **POST** /postGuest | postGuest
*GuestApi* | [**post_guests_to_room_post**](cloudbeds_pms_v1_3/docs/GuestApi.md#post_guests_to_room_post) | **POST** /postGuestsToRoom | postGuestsToRoom
*GuestApi* | [**put_guest_note_put**](cloudbeds_pms_v1_3/docs/GuestApi.md#put_guest_note_put) | **PUT** /putGuestNote | putGuestNote
*GuestApi* | [**put_guest_put**](cloudbeds_pms_v1_3/docs/GuestApi.md#put_guest_put) | **PUT** /putGuest | putGuest
*HotelApi* | [**get_files_get**](cloudbeds_pms_v1_3/docs/HotelApi.md#get_files_get) | **GET** /getFiles | getFiles
*HotelApi* | [**get_hotel_details_get**](cloudbeds_pms_v1_3/docs/HotelApi.md#get_hotel_details_get) | **GET** /getHotelDetails | getHotelDetails
*HotelApi* | [**get_hotels_get**](cloudbeds_pms_v1_3/docs/HotelApi.md#get_hotels_get) | **GET** /getHotels | getHotels
*HotelApi* | [**post_file_post**](cloudbeds_pms_v1_3/docs/HotelApi.md#post_file_post) | **POST** /postFile | postFile
*HouseAccountApi* | [**get_house_account_details_get**](cloudbeds_pms_v1_3/docs/HouseAccountApi.md#get_house_account_details_get) | **GET** /getHouseAccountDetails | getHouseAccountDetails
*HouseAccountApi* | [**get_house_account_list_get**](cloudbeds_pms_v1_3/docs/HouseAccountApi.md#get_house_account_list_get) | **GET** /getHouseAccountList | getHouseAccountList
*HouseAccountApi* | [**post_new_house_account_post**](cloudbeds_pms_v1_3/docs/HouseAccountApi.md#post_new_house_account_post) | **POST** /postNewHouseAccount | postNewHouseAccount
*HouseAccountApi* | [**put_house_account_status_put**](cloudbeds_pms_v1_3/docs/HouseAccountApi.md#put_house_account_status_put) | **PUT** /putHouseAccountStatus | putHouseAccountStatus
*HousekeepingApi* | [**get_housekeepers_get**](cloudbeds_pms_v1_3/docs/HousekeepingApi.md#get_housekeepers_get) | **GET** /getHousekeepers | getHousekeepers
*HousekeepingApi* | [**get_housekeeping_status_get**](cloudbeds_pms_v1_3/docs/HousekeepingApi.md#get_housekeeping_status_get) | **GET** /getHousekeepingStatus | getHousekeepingStatus
*HousekeepingApi* | [**post_housekeeper_post**](cloudbeds_pms_v1_3/docs/HousekeepingApi.md#post_housekeeper_post) | **POST** /postHousekeeper | postHousekeeper
*HousekeepingApi* | [**post_housekeeping_assignment_post**](cloudbeds_pms_v1_3/docs/HousekeepingApi.md#post_housekeeping_assignment_post) | **POST** /postHousekeepingAssignment | postHousekeepingAssignment
*HousekeepingApi* | [**post_housekeeping_status_post**](cloudbeds_pms_v1_3/docs/HousekeepingApi.md#post_housekeeping_status_post) | **POST** /postHousekeepingStatus | postHousekeepingStatus
*HousekeepingApi* | [**put_housekeeper_put**](cloudbeds_pms_v1_3/docs/HousekeepingApi.md#put_housekeeper_put) | **PUT** /putHousekeeper | putHousekeeper
*ImportApi* | [**import_dummy_reservations_get**](cloudbeds_pms_v1_3/docs/ImportApi.md#import_dummy_reservations_get) | **GET** /import/dummyReservations | GetImportDummyReservations
*ImportApi* | [**import_tours_get**](cloudbeds_pms_v1_3/docs/ImportApi.md#import_tours_get) | **GET** /import/tours | GetImportTours
*IntegrationApi* | [**delete_webhook_delete**](cloudbeds_pms_v1_3/docs/IntegrationApi.md#delete_webhook_delete) | **DELETE** /deleteWebhook | deleteWebhook
*IntegrationApi* | [**get_app_settings_get**](cloudbeds_pms_v1_3/docs/IntegrationApi.md#get_app_settings_get) | **GET** /getAppSettings | getAppSettings
*IntegrationApi* | [**get_app_state_get**](cloudbeds_pms_v1_3/docs/IntegrationApi.md#get_app_state_get) | **GET** /getAppState | getAppState
*IntegrationApi* | [**get_webhooks_get**](cloudbeds_pms_v1_3/docs/IntegrationApi.md#get_webhooks_get) | **GET** /getWebhooks | getWebhooks
*IntegrationApi* | [**post_app_error_post**](cloudbeds_pms_v1_3/docs/IntegrationApi.md#post_app_error_post) | **POST** /postAppError | postAppError
*IntegrationApi* | [**post_app_settings_post**](cloudbeds_pms_v1_3/docs/IntegrationApi.md#post_app_settings_post) | **POST** /postAppSettings | postAppSettings
*IntegrationApi* | [**post_app_state_internal_post**](cloudbeds_pms_v1_3/docs/IntegrationApi.md#post_app_state_internal_post) | **POST** /postAppStateInternal | postAppStateInternal
*IntegrationApi* | [**post_app_state_post**](cloudbeds_pms_v1_3/docs/IntegrationApi.md#post_app_state_post) | **POST** /postAppState | postAppState
*IntegrationApi* | [**post_government_receipt_post**](cloudbeds_pms_v1_3/docs/IntegrationApi.md#post_government_receipt_post) | **POST** /postGovernmentReceipt | postGovernmentReceipt
*IntegrationApi* | [**post_webhook_post**](cloudbeds_pms_v1_3/docs/IntegrationApi.md#post_webhook_post) | **POST** /postWebhook | postWebhook
*InvoicesApi* | [**get_invoice_get**](cloudbeds_pms_v1_3/docs/InvoicesApi.md#get_invoice_get) | **GET** /getInvoice | getInvoice
*InvoicesApi* | [**invoice_get**](cloudbeds_pms_v1_3/docs/InvoicesApi.md#invoice_get) | **GET** /invoice | invoice
*InvoicesApi* | [**patch_invoice_post**](cloudbeds_pms_v1_3/docs/InvoicesApi.md#patch_invoice_post) | **POST** /patchInvoice | patchInvoice
*ItemApi* | [**append_custom_item_post**](cloudbeds_pms_v1_3/docs/ItemApi.md#append_custom_item_post) | **POST** /appendCustomItem | appendCustomItem
*ItemApi* | [**delete_item_from_reservation_delete**](cloudbeds_pms_v1_3/docs/ItemApi.md#delete_item_from_reservation_delete) | **DELETE** /deleteItemFromReservation | deleteItemFromReservation
*ItemApi* | [**get_item_categories_get**](cloudbeds_pms_v1_3/docs/ItemApi.md#get_item_categories_get) | **GET** /getItemCategories | getItemCategories
*ItemApi* | [**get_item_get**](cloudbeds_pms_v1_3/docs/ItemApi.md#get_item_get) | **GET** /getItem | getItem
*ItemApi* | [**get_items_get**](cloudbeds_pms_v1_3/docs/ItemApi.md#get_items_get) | **GET** /getItems | getItems
*ItemApi* | [**post_custom_item_post**](cloudbeds_pms_v1_3/docs/ItemApi.md#post_custom_item_post) | **POST** /postCustomItem | postCustomItem
*ItemApi* | [**post_item_category_post**](cloudbeds_pms_v1_3/docs/ItemApi.md#post_item_category_post) | **POST** /postItemCategory | postItemCategory
*ItemApi* | [**post_item_post**](cloudbeds_pms_v1_3/docs/ItemApi.md#post_item_post) | **POST** /postItem | postItem
*ItemApi* | [**post_item_to_reservation_post**](cloudbeds_pms_v1_3/docs/ItemApi.md#post_item_to_reservation_post) | **POST** /postItemToReservation | postItemToReservation
*ItemApi* | [**post_items_to_inventory_post**](cloudbeds_pms_v1_3/docs/ItemApi.md#post_items_to_inventory_post) | **POST** /postItemsToInventory | postItemsToInventory
*ItemApi* | [**post_void_item_post**](cloudbeds_pms_v1_3/docs/ItemApi.md#post_void_item_post) | **POST** /postVoidItem | postVoidItem
*ItemApi* | [**put_item_to_inventory_put**](cloudbeds_pms_v1_3/docs/ItemApi.md#put_item_to_inventory_put) | **PUT** /putItemToInventory | putItemToInventory
*PackageApi* | [**get_package_names_get**](cloudbeds_pms_v1_3/docs/PackageApi.md#get_package_names_get) | **GET** /getPackageNames | getPackageNames
*PackageApi* | [**get_packages_get**](cloudbeds_pms_v1_3/docs/PackageApi.md#get_packages_get) | **GET** /getPackages | getPackages
*PaymentApi* | [**get_payment_methods_get**](cloudbeds_pms_v1_3/docs/PaymentApi.md#get_payment_methods_get) | **GET** /getPaymentMethods | getPaymentMethods
*PaymentApi* | [**get_payments_capabilities_get**](cloudbeds_pms_v1_3/docs/PaymentApi.md#get_payments_capabilities_get) | **GET** /getPaymentsCapabilities | getPaymentsCapabilities
*PaymentApi* | [**get_payments_get**](cloudbeds_pms_v1_3/docs/PaymentApi.md#get_payments_get) | **GET** /getPayments | getPayments
*PaymentApi* | [**get_pending_transactions_get**](cloudbeds_pms_v1_3/docs/PaymentApi.md#get_pending_transactions_get) | **GET** /getPendingTransactions | getPendingTransactions
*PaymentApi* | [**get_transactions_get**](cloudbeds_pms_v1_3/docs/PaymentApi.md#get_transactions_get) | **GET** /getTransactions | getTransactions
*PaymentApi* | [**post_charge_post**](cloudbeds_pms_v1_3/docs/PaymentApi.md#post_charge_post) | **POST** /postCharge | postCharge
*PaymentApi* | [**post_credit_card_post**](cloudbeds_pms_v1_3/docs/PaymentApi.md#post_credit_card_post) | **POST** /postCreditCard | postCreditCard
*PaymentApi* | [**post_custom_payment_method_post**](cloudbeds_pms_v1_3/docs/PaymentApi.md#post_custom_payment_method_post) | **POST** /postCustomPaymentMethod | postCustomPaymentMethod
*PaymentApi* | [**post_payment_cash_post**](cloudbeds_pms_v1_3/docs/PaymentApi.md#post_payment_cash_post) | **POST** /postPaymentCash | postPaymentCash
*PaymentApi* | [**post_payment_credit_card_post**](cloudbeds_pms_v1_3/docs/PaymentApi.md#post_payment_credit_card_post) | **POST** /postPaymentCreditCard | postPaymentCreditCard
*PaymentApi* | [**post_payment_post**](cloudbeds_pms_v1_3/docs/PaymentApi.md#post_payment_post) | **POST** /postPayment | postPayment
*PaymentApi* | [**post_void_payment_post**](cloudbeds_pms_v1_3/docs/PaymentApi.md#post_void_payment_post) | **POST** /postVoidPayment | postVoidPayment
*RateApi* | [**get_rate_get**](cloudbeds_pms_v1_3/docs/RateApi.md#get_rate_get) | **GET** /getRate | getRate
*RateApi* | [**get_rate_jobs_get**](cloudbeds_pms_v1_3/docs/RateApi.md#get_rate_jobs_get) | **GET** /getRateJobs | getRateJobs
*RateApi* | [**get_rate_plans_get**](cloudbeds_pms_v1_3/docs/RateApi.md#get_rate_plans_get) | **GET** /getRatePlans | getRatePlans
*RateApi* | [**patch_rate_post**](cloudbeds_pms_v1_3/docs/RateApi.md#patch_rate_post) | **POST** /patchRate | patchRate
*RateApi* | [**put_rate_put**](cloudbeds_pms_v1_3/docs/RateApi.md#put_rate_put) | **PUT** /putRate | putRate
*ReservationApi* | [**delete_reservation_note_delete**](cloudbeds_pms_v1_3/docs/ReservationApi.md#delete_reservation_note_delete) | **DELETE** /deleteReservationNote | deleteReservationNote
*ReservationApi* | [**get_reservation_arrivals_get**](cloudbeds_pms_v1_3/docs/ReservationApi.md#get_reservation_arrivals_get) | **GET** /getReservationArrivals | getReservationArrivals
*ReservationApi* | [**get_reservation_assignments_get**](cloudbeds_pms_v1_3/docs/ReservationApi.md#get_reservation_assignments_get) | **GET** /getReservationAssignments | getReservationAssignments
*ReservationApi* | [**get_reservation_departures_get**](cloudbeds_pms_v1_3/docs/ReservationApi.md#get_reservation_departures_get) | **GET** /getReservationDepartures | getReservationDepartures
*ReservationApi* | [**get_reservation_get**](cloudbeds_pms_v1_3/docs/ReservationApi.md#get_reservation_get) | **GET** /getReservation | getReservation
*ReservationApi* | [**get_reservation_in_house_get**](cloudbeds_pms_v1_3/docs/ReservationApi.md#get_reservation_in_house_get) | **GET** /getReservationInHouse | getReservationInHouse
*ReservationApi* | [**get_reservation_invoice_information_get**](cloudbeds_pms_v1_3/docs/ReservationApi.md#get_reservation_invoice_information_get) | **GET** /getReservationInvoiceInformation | getReservationInvoiceInformation
*ReservationApi* | [**get_reservation_notes_get**](cloudbeds_pms_v1_3/docs/ReservationApi.md#get_reservation_notes_get) | **GET** /getReservationNotes | getReservationNotes
*ReservationApi* | [**get_reservations_get**](cloudbeds_pms_v1_3/docs/ReservationApi.md#get_reservations_get) | **GET** /getReservations | getReservations
*ReservationApi* | [**get_reservations_with_rate_details_get**](cloudbeds_pms_v1_3/docs/ReservationApi.md#get_reservations_with_rate_details_get) | **GET** /getReservationsWithRateDetails | getReservationsWithRateDetails
*ReservationApi* | [**get_sources_get**](cloudbeds_pms_v1_3/docs/ReservationApi.md#get_sources_get) | **GET** /getSources | getSources
*ReservationApi* | [**post_reservation_check_in_post**](cloudbeds_pms_v1_3/docs/ReservationApi.md#post_reservation_check_in_post) | **POST** /postReservationCheckIn | postReservationCheckIn
*ReservationApi* | [**post_reservation_check_out_post**](cloudbeds_pms_v1_3/docs/ReservationApi.md#post_reservation_check_out_post) | **POST** /postReservationCheckOut | postReservationCheckOut
*ReservationApi* | [**post_reservation_document_post**](cloudbeds_pms_v1_3/docs/ReservationApi.md#post_reservation_document_post) | **POST** /postReservationDocument | postReservationDocument
*ReservationApi* | [**post_reservation_note_post**](cloudbeds_pms_v1_3/docs/ReservationApi.md#post_reservation_note_post) | **POST** /postReservationNote | postReservationNote
*ReservationApi* | [**post_reservation_post**](cloudbeds_pms_v1_3/docs/ReservationApi.md#post_reservation_post) | **POST** /postReservation | postReservation
*ReservationApi* | [**put_reservation_details_put**](cloudbeds_pms_v1_3/docs/ReservationApi.md#put_reservation_details_put) | **PUT** /putReservationDetails | putReservationDetails
*ReservationApi* | [**put_reservation_note_put**](cloudbeds_pms_v1_3/docs/ReservationApi.md#put_reservation_note_put) | **PUT** /putReservationNote | putReservationNote
*ReservationApi* | [**put_reservation_put**](cloudbeds_pms_v1_3/docs/ReservationApi.md#put_reservation_put) | **PUT** /putReservation | putReservation
*RoomApi* | [**delete_room_block_delete**](cloudbeds_pms_v1_3/docs/RoomApi.md#delete_room_block_delete) | **DELETE** /deleteRoomBlock | deleteRoomBlock
*RoomApi* | [**get_available_room_types_get**](cloudbeds_pms_v1_3/docs/RoomApi.md#get_available_room_types_get) | **GET** /getAvailableRoomTypes | getAvailableRoomTypes
*RoomApi* | [**get_reservation_room_details_get**](cloudbeds_pms_v1_3/docs/RoomApi.md#get_reservation_room_details_get) | **GET** /getReservationRoomDetails | getReservationRoomDetails
*RoomApi* | [**get_room_blocks_get**](cloudbeds_pms_v1_3/docs/RoomApi.md#get_room_blocks_get) | **GET** /getRoomBlocks | getRoomBlocks
*RoomApi* | [**get_room_types_get**](cloudbeds_pms_v1_3/docs/RoomApi.md#get_room_types_get) | **GET** /getRoomTypes | getRoomTypes
*RoomApi* | [**get_rooms_fees_and_taxes_get**](cloudbeds_pms_v1_3/docs/RoomApi.md#get_rooms_fees_and_taxes_get) | **GET** /getRoomsFeesAndTaxes | getRoomsFeesAndTaxes
*RoomApi* | [**get_rooms_get**](cloudbeds_pms_v1_3/docs/RoomApi.md#get_rooms_get) | **GET** /getRooms | getRooms
*RoomApi* | [**get_rooms_unassigned_get**](cloudbeds_pms_v1_3/docs/RoomApi.md#get_rooms_unassigned_get) | **GET** /getRoomsUnassigned | getRoomsUnassigned
*RoomApi* | [**post_room_assign_post**](cloudbeds_pms_v1_3/docs/RoomApi.md#post_room_assign_post) | **POST** /postRoomAssign | postRoomAssign
*RoomApi* | [**post_room_block_post**](cloudbeds_pms_v1_3/docs/RoomApi.md#post_room_block_post) | **POST** /postRoomBlock | postRoomBlock
*RoomApi* | [**post_room_check_in_post**](cloudbeds_pms_v1_3/docs/RoomApi.md#post_room_check_in_post) | **POST** /postRoomCheckIn | postRoomCheckIn
*RoomApi* | [**post_room_check_out_post**](cloudbeds_pms_v1_3/docs/RoomApi.md#post_room_check_out_post) | **POST** /postRoomCheckOut | postRoomCheckOut
*RoomApi* | [**post_room_type_post**](cloudbeds_pms_v1_3/docs/RoomApi.md#post_room_type_post) | **POST** /postRoomType | postRoomType
*RoomApi* | [**put_room_block_put**](cloudbeds_pms_v1_3/docs/RoomApi.md#put_room_block_put) | **PUT** /putRoomBlock | putRoomBlock
*RoomsApi* | [**get_hotel_room_types_get**](cloudbeds_pms_v1_3/docs/RoomsApi.md#get_hotel_room_types_get) | **GET** /getHotelRoomTypes | getHotelRoomTypes
*TaxesAndFeesApi* | [**get_taxes_and_fees_get**](cloudbeds_pms_v1_3/docs/TaxesAndFeesApi.md#get_taxes_and_fees_get) | **GET** /getTaxesAndFees | getTaxesAndFees
*UserApi* | [**get_users_get**](cloudbeds_pms_v1_3/docs/UserApi.md#get_users_get) | **GET** /getUsers | getUsers


## Documentation For Models

 - [DeleteAdjustmentResponse](cloudbeds_pms_v1_3/docs/DeleteAdjustmentResponse.md)
 - [DeleteGuestNoteResponse](cloudbeds_pms_v1_3/docs/DeleteGuestNoteResponse.md)
 - [DeleteItemFromReservationResponse](cloudbeds_pms_v1_3/docs/DeleteItemFromReservationResponse.md)
 - [DeleteReservationNoteResponse](cloudbeds_pms_v1_3/docs/DeleteReservationNoteResponse.md)
 - [DeleteRoomBlockResponse](cloudbeds_pms_v1_3/docs/DeleteRoomBlockResponse.md)
 - [DeleteWebhookResponse](cloudbeds_pms_v1_3/docs/DeleteWebhookResponse.md)
 - [GetAdjustmentResponse](cloudbeds_pms_v1_3/docs/GetAdjustmentResponse.md)
 - [GetAdjustmentResponseData](cloudbeds_pms_v1_3/docs/GetAdjustmentResponseData.md)
 - [GetAdjustmentsResponse](cloudbeds_pms_v1_3/docs/GetAdjustmentsResponse.md)
 - [GetAdjustmentsResponseData](cloudbeds_pms_v1_3/docs/GetAdjustmentsResponseData.md)
 - [GetAllotmentBlocksResponse](cloudbeds_pms_v1_3/docs/GetAllotmentBlocksResponse.md)
 - [GetAllotmentBlocksResponseDataInner](cloudbeds_pms_v1_3/docs/GetAllotmentBlocksResponseDataInner.md)
 - [GetAllotmentBlocksResponseDataInnerAllotmentIntervalsInner](cloudbeds_pms_v1_3/docs/GetAllotmentBlocksResponseDataInnerAllotmentIntervalsInner.md)
 - [GetAllotmentBlocksResponseDataInnerAllotmentIntervalsInnerAvailabilityInner](cloudbeds_pms_v1_3/docs/GetAllotmentBlocksResponseDataInnerAllotmentIntervalsInnerAvailabilityInner.md)
 - [GetAllotmentBlocksResponseDataInnerAllotmentIntervalsInnerRestrictions](cloudbeds_pms_v1_3/docs/GetAllotmentBlocksResponseDataInnerAllotmentIntervalsInnerRestrictions.md)
 - [GetAllotmentBlocksResponseDataInnerAutoReleaseInner](cloudbeds_pms_v1_3/docs/GetAllotmentBlocksResponseDataInnerAutoReleaseInner.md)
 - [GetAppPropertySettingsResponse](cloudbeds_pms_v1_3/docs/GetAppPropertySettingsResponse.md)
 - [GetAppPropertySettingsResponseData](cloudbeds_pms_v1_3/docs/GetAppPropertySettingsResponseData.md)
 - [GetAppPropertySettingsResponseDataOneOf](cloudbeds_pms_v1_3/docs/GetAppPropertySettingsResponseDataOneOf.md)
 - [GetAppSettingsResponse](cloudbeds_pms_v1_3/docs/GetAppSettingsResponse.md)
 - [GetAppSettingsResponseData](cloudbeds_pms_v1_3/docs/GetAppSettingsResponseData.md)
 - [GetAppStateResponse](cloudbeds_pms_v1_3/docs/GetAppStateResponse.md)
 - [GetAppStateResponseData](cloudbeds_pms_v1_3/docs/GetAppStateResponseData.md)
 - [GetAsyncApiJobResponse](cloudbeds_pms_v1_3/docs/GetAsyncApiJobResponse.md)
 - [GetAsyncApiJobResponseDataInner](cloudbeds_pms_v1_3/docs/GetAsyncApiJobResponseDataInner.md)
 - [GetAsyncApiJobResponseDataInnerUpdatesInner](cloudbeds_pms_v1_3/docs/GetAsyncApiJobResponseDataInnerUpdatesInner.md)
 - [GetAsyncApiJobResponseDataInnerUpdatesInnerAllotmentIntervalsInner](cloudbeds_pms_v1_3/docs/GetAsyncApiJobResponseDataInnerUpdatesInnerAllotmentIntervalsInner.md)
 - [GetAsyncApiJobResponseDataInnerUpdatesInnerAllotmentIntervalsInnerAvailability](cloudbeds_pms_v1_3/docs/GetAsyncApiJobResponseDataInnerUpdatesInnerAllotmentIntervalsInnerAvailability.md)
 - [GetAsyncApiJobResponseDataInnerUpdatesInnerAllotmentIntervalsInnerAvailabilityGuestPricing](cloudbeds_pms_v1_3/docs/GetAsyncApiJobResponseDataInnerUpdatesInnerAllotmentIntervalsInnerAvailabilityGuestPricing.md)
 - [GetAsyncApiJobResponseDataInnerUpdatesInnerAllotmentIntervalsInnerRestrictions](cloudbeds_pms_v1_3/docs/GetAsyncApiJobResponseDataInnerUpdatesInnerAllotmentIntervalsInnerRestrictions.md)
 - [GetAsyncApiJobResponseDataInnerUpdatesInnerAutoRelease](cloudbeds_pms_v1_3/docs/GetAsyncApiJobResponseDataInnerUpdatesInnerAutoRelease.md)
 - [GetAvailableRoomTypesResponse](cloudbeds_pms_v1_3/docs/GetAvailableRoomTypesResponse.md)
 - [GetAvailableRoomTypesResponseDataInner](cloudbeds_pms_v1_3/docs/GetAvailableRoomTypesResponseDataInner.md)
 - [GetAvailableRoomTypesResponseDataInnerPropertyCurrencyInner](cloudbeds_pms_v1_3/docs/GetAvailableRoomTypesResponseDataInnerPropertyCurrencyInner.md)
 - [GetAvailableRoomTypesResponseDataInnerPropertyRoomsInner](cloudbeds_pms_v1_3/docs/GetAvailableRoomTypesResponseDataInnerPropertyRoomsInner.md)
 - [GetAvailableRoomTypesResponseDataInnerPropertyRoomsInnerIndividualRoomsInner](cloudbeds_pms_v1_3/docs/GetAvailableRoomTypesResponseDataInnerPropertyRoomsInnerIndividualRoomsInner.md)
 - [GetAvailableRoomTypesResponseDataInnerPropertyRoomsInnerRoomRateDetailedInner](cloudbeds_pms_v1_3/docs/GetAvailableRoomTypesResponseDataInnerPropertyRoomsInnerRoomRateDetailedInner.md)
 - [GetCurrencySettingsResponse](cloudbeds_pms_v1_3/docs/GetCurrencySettingsResponse.md)
 - [GetCurrencySettingsResponseData](cloudbeds_pms_v1_3/docs/GetCurrencySettingsResponseData.md)
 - [GetCurrencySettingsResponseDataFormat](cloudbeds_pms_v1_3/docs/GetCurrencySettingsResponseDataFormat.md)
 - [GetCurrencySettingsResponseDataRates](cloudbeds_pms_v1_3/docs/GetCurrencySettingsResponseDataRates.md)
 - [GetCurrencySettingsResponseDataRatesFixedInner](cloudbeds_pms_v1_3/docs/GetCurrencySettingsResponseDataRatesFixedInner.md)
 - [GetCustomFieldsResponse](cloudbeds_pms_v1_3/docs/GetCustomFieldsResponse.md)
 - [GetCustomFieldsResponseDataInner](cloudbeds_pms_v1_3/docs/GetCustomFieldsResponseDataInner.md)
 - [GetDashboardResponse](cloudbeds_pms_v1_3/docs/GetDashboardResponse.md)
 - [GetDashboardResponseData](cloudbeds_pms_v1_3/docs/GetDashboardResponseData.md)
 - [GetEmailScheduleResponse](cloudbeds_pms_v1_3/docs/GetEmailScheduleResponse.md)
 - [GetEmailScheduleResponseDataInner](cloudbeds_pms_v1_3/docs/GetEmailScheduleResponseDataInner.md)
 - [GetEmailTemplatesResponse](cloudbeds_pms_v1_3/docs/GetEmailTemplatesResponse.md)
 - [GetEmailTemplatesResponseDataInner](cloudbeds_pms_v1_3/docs/GetEmailTemplatesResponseDataInner.md)
 - [GetFilesResponse](cloudbeds_pms_v1_3/docs/GetFilesResponse.md)
 - [GetFilesResponseDataInner](cloudbeds_pms_v1_3/docs/GetFilesResponseDataInner.md)
 - [GetGroupNotesResponse](cloudbeds_pms_v1_3/docs/GetGroupNotesResponse.md)
 - [GetGroupNotesResponseData](cloudbeds_pms_v1_3/docs/GetGroupNotesResponseData.md)
 - [GetGroupsResponse](cloudbeds_pms_v1_3/docs/GetGroupsResponse.md)
 - [GetGroupsResponseDataInner](cloudbeds_pms_v1_3/docs/GetGroupsResponseDataInner.md)
 - [GetGuestListResponse](cloudbeds_pms_v1_3/docs/GetGuestListResponse.md)
 - [GetGuestListResponseDataValue](cloudbeds_pms_v1_3/docs/GetGuestListResponseDataValue.md)
 - [GetGuestListResponseDataValueGuestNotesInner](cloudbeds_pms_v1_3/docs/GetGuestListResponseDataValueGuestNotesInner.md)
 - [GetGuestNotesResponse](cloudbeds_pms_v1_3/docs/GetGuestNotesResponse.md)
 - [GetGuestNotesResponseDataInner](cloudbeds_pms_v1_3/docs/GetGuestNotesResponseDataInner.md)
 - [GetGuestResponse](cloudbeds_pms_v1_3/docs/GetGuestResponse.md)
 - [GetGuestResponseData](cloudbeds_pms_v1_3/docs/GetGuestResponseData.md)
 - [GetGuestResponseDataBirthDate](cloudbeds_pms_v1_3/docs/GetGuestResponseDataBirthDate.md)
 - [GetGuestResponseDataCustomFieldsInner](cloudbeds_pms_v1_3/docs/GetGuestResponseDataCustomFieldsInner.md)
 - [GetGuestResponseDataDocumentExpirationDate](cloudbeds_pms_v1_3/docs/GetGuestResponseDataDocumentExpirationDate.md)
 - [GetGuestResponseDataDocumentIssueDate](cloudbeds_pms_v1_3/docs/GetGuestResponseDataDocumentIssueDate.md)
 - [GetGuestsByFilterResponse](cloudbeds_pms_v1_3/docs/GetGuestsByFilterResponse.md)
 - [GetGuestsByFilterResponseDataInner](cloudbeds_pms_v1_3/docs/GetGuestsByFilterResponseDataInner.md)
 - [GetGuestsByStatusResponse](cloudbeds_pms_v1_3/docs/GetGuestsByStatusResponse.md)
 - [GetGuestsByStatusResponseDataInner](cloudbeds_pms_v1_3/docs/GetGuestsByStatusResponseDataInner.md)
 - [GetGuestsModifiedResponse](cloudbeds_pms_v1_3/docs/GetGuestsModifiedResponse.md)
 - [GetGuestsModifiedResponseDataInner](cloudbeds_pms_v1_3/docs/GetGuestsModifiedResponseDataInner.md)
 - [GetGuestsModifiedResponseDataInnerCustomFieldsInner](cloudbeds_pms_v1_3/docs/GetGuestsModifiedResponseDataInnerCustomFieldsInner.md)
 - [GetHotelDetailsResponse](cloudbeds_pms_v1_3/docs/GetHotelDetailsResponse.md)
 - [GetHotelDetailsResponseData](cloudbeds_pms_v1_3/docs/GetHotelDetailsResponseData.md)
 - [GetHotelDetailsResponseDataPropertyAddress](cloudbeds_pms_v1_3/docs/GetHotelDetailsResponseDataPropertyAddress.md)
 - [GetHotelDetailsResponseDataPropertyCurrency](cloudbeds_pms_v1_3/docs/GetHotelDetailsResponseDataPropertyCurrency.md)
 - [GetHotelDetailsResponseDataPropertyImageInner](cloudbeds_pms_v1_3/docs/GetHotelDetailsResponseDataPropertyImageInner.md)
 - [GetHotelDetailsResponseDataPropertyPolicy](cloudbeds_pms_v1_3/docs/GetHotelDetailsResponseDataPropertyPolicy.md)
 - [GetHotelRoomTypesResponse](cloudbeds_pms_v1_3/docs/GetHotelRoomTypesResponse.md)
 - [GetHotelsResponse](cloudbeds_pms_v1_3/docs/GetHotelsResponse.md)
 - [GetHotelsResponseDataInner](cloudbeds_pms_v1_3/docs/GetHotelsResponseDataInner.md)
 - [GetHotelsResponseDataInnerPropertyCurrencyInner](cloudbeds_pms_v1_3/docs/GetHotelsResponseDataInnerPropertyCurrencyInner.md)
 - [GetHouseAccountDetailsResponse](cloudbeds_pms_v1_3/docs/GetHouseAccountDetailsResponse.md)
 - [GetHouseAccountDetailsResponseData](cloudbeds_pms_v1_3/docs/GetHouseAccountDetailsResponseData.md)
 - [GetHouseAccountDetailsResponseDataRecordsInner](cloudbeds_pms_v1_3/docs/GetHouseAccountDetailsResponseDataRecordsInner.md)
 - [GetHouseAccountDetailsResponseDataTotalInner](cloudbeds_pms_v1_3/docs/GetHouseAccountDetailsResponseDataTotalInner.md)
 - [GetHouseAccountListResponse](cloudbeds_pms_v1_3/docs/GetHouseAccountListResponse.md)
 - [GetHouseAccountListResponseDataInner](cloudbeds_pms_v1_3/docs/GetHouseAccountListResponseDataInner.md)
 - [GetHousekeepersResponse](cloudbeds_pms_v1_3/docs/GetHousekeepersResponse.md)
 - [GetHousekeepersResponseDataInner](cloudbeds_pms_v1_3/docs/GetHousekeepersResponseDataInner.md)
 - [GetHousekeepingStatusResponse](cloudbeds_pms_v1_3/docs/GetHousekeepingStatusResponse.md)
 - [GetHousekeepingStatusResponseDataInner](cloudbeds_pms_v1_3/docs/GetHousekeepingStatusResponseDataInner.md)
 - [GetImportDummyReservationsResponse](cloudbeds_pms_v1_3/docs/GetImportDummyReservationsResponse.md)
 - [GetImportToursResponse](cloudbeds_pms_v1_3/docs/GetImportToursResponse.md)
 - [GetInvoiceResponse](cloudbeds_pms_v1_3/docs/GetInvoiceResponse.md)
 - [GetInvoiceResponseData](cloudbeds_pms_v1_3/docs/GetInvoiceResponseData.md)
 - [GetInvoiceResponseDataBilledTo](cloudbeds_pms_v1_3/docs/GetInvoiceResponseDataBilledTo.md)
 - [GetInvoiceResponseDataItemsInner](cloudbeds_pms_v1_3/docs/GetInvoiceResponseDataItemsInner.md)
 - [GetInvoiceResponseDataItemsInnerFeesInner](cloudbeds_pms_v1_3/docs/GetInvoiceResponseDataItemsInnerFeesInner.md)
 - [GetInvoiceResponseDataItemsInnerTaxesInner](cloudbeds_pms_v1_3/docs/GetInvoiceResponseDataItemsInnerTaxesInner.md)
 - [GetItemCategoriesResponse](cloudbeds_pms_v1_3/docs/GetItemCategoriesResponse.md)
 - [GetItemCategoriesResponseDataInner](cloudbeds_pms_v1_3/docs/GetItemCategoriesResponseDataInner.md)
 - [GetItemResponse](cloudbeds_pms_v1_3/docs/GetItemResponse.md)
 - [GetItemResponseData](cloudbeds_pms_v1_3/docs/GetItemResponseData.md)
 - [GetItemResponseDataFeesInner](cloudbeds_pms_v1_3/docs/GetItemResponseDataFeesInner.md)
 - [GetItemResponseDataTaxesInner](cloudbeds_pms_v1_3/docs/GetItemResponseDataTaxesInner.md)
 - [GetItemsResponse](cloudbeds_pms_v1_3/docs/GetItemsResponse.md)
 - [GetItemsResponseDataInner](cloudbeds_pms_v1_3/docs/GetItemsResponseDataInner.md)
 - [GetListAllotmentBlockNotesResponse](cloudbeds_pms_v1_3/docs/GetListAllotmentBlockNotesResponse.md)
 - [GetListAllotmentBlockNotesResponseDataInner](cloudbeds_pms_v1_3/docs/GetListAllotmentBlockNotesResponseDataInner.md)
 - [GetMetadataResponse](cloudbeds_pms_v1_3/docs/GetMetadataResponse.md)
 - [GetMetadataResponseData](cloudbeds_pms_v1_3/docs/GetMetadataResponseData.md)
 - [GetMetadataResponseDataApi](cloudbeds_pms_v1_3/docs/GetMetadataResponseDataApi.md)
 - [GetPackagesResponse](cloudbeds_pms_v1_3/docs/GetPackagesResponse.md)
 - [GetPackagesResponseData](cloudbeds_pms_v1_3/docs/GetPackagesResponseData.md)
 - [GetPaymentMethodsResponse](cloudbeds_pms_v1_3/docs/GetPaymentMethodsResponse.md)
 - [GetPaymentMethodsResponseData](cloudbeds_pms_v1_3/docs/GetPaymentMethodsResponseData.md)
 - [GetPaymentMethodsResponseDataGatewayInner](cloudbeds_pms_v1_3/docs/GetPaymentMethodsResponseDataGatewayInner.md)
 - [GetPaymentMethodsResponseDataMethodsInner](cloudbeds_pms_v1_3/docs/GetPaymentMethodsResponseDataMethodsInner.md)
 - [GetPaymentMethodsResponseDataMethodsInnerCardTypesInner](cloudbeds_pms_v1_3/docs/GetPaymentMethodsResponseDataMethodsInnerCardTypesInner.md)
 - [GetPaymentsCapabilitiesResponse](cloudbeds_pms_v1_3/docs/GetPaymentsCapabilitiesResponse.md)
 - [GetPaymentsCapabilitiesResponseDataInner](cloudbeds_pms_v1_3/docs/GetPaymentsCapabilitiesResponseDataInner.md)
 - [GetPaymentsResponse](cloudbeds_pms_v1_3/docs/GetPaymentsResponse.md)
 - [GetPaymentsResponseDataInner](cloudbeds_pms_v1_3/docs/GetPaymentsResponseDataInner.md)
 - [GetPaymentsResponseDataInnerPaymentAllocationInner](cloudbeds_pms_v1_3/docs/GetPaymentsResponseDataInnerPaymentAllocationInner.md)
 - [GetPendingTransactionsResponse](cloudbeds_pms_v1_3/docs/GetPendingTransactionsResponse.md)
 - [GetPendingTransactionsResponseDataInner](cloudbeds_pms_v1_3/docs/GetPendingTransactionsResponseDataInner.md)
 - [GetRateJobsResponse](cloudbeds_pms_v1_3/docs/GetRateJobsResponse.md)
 - [GetRateJobsResponseDataInner](cloudbeds_pms_v1_3/docs/GetRateJobsResponseDataInner.md)
 - [GetRateJobsResponseDataInnerUpdatesInner](cloudbeds_pms_v1_3/docs/GetRateJobsResponseDataInnerUpdatesInner.md)
 - [GetRatePlansResponse](cloudbeds_pms_v1_3/docs/GetRatePlansResponse.md)
 - [GetRatePlansResponseDataInner](cloudbeds_pms_v1_3/docs/GetRatePlansResponseDataInner.md)
 - [GetRatePlansResponseDataInnerAddOnsInner](cloudbeds_pms_v1_3/docs/GetRatePlansResponseDataInnerAddOnsInner.md)
 - [GetRatePlansResponseDataInnerRoomRateDetailedInner](cloudbeds_pms_v1_3/docs/GetRatePlansResponseDataInnerRoomRateDetailedInner.md)
 - [GetRateResponse](cloudbeds_pms_v1_3/docs/GetRateResponse.md)
 - [GetRateResponseData](cloudbeds_pms_v1_3/docs/GetRateResponseData.md)
 - [GetRateResponseDataRoomRateDetailedInner](cloudbeds_pms_v1_3/docs/GetRateResponseDataRoomRateDetailedInner.md)
 - [GetReservationArrivalsResponse](cloudbeds_pms_v1_3/docs/GetReservationArrivalsResponse.md)
 - [GetReservationArrivalsResponseDataInner](cloudbeds_pms_v1_3/docs/GetReservationArrivalsResponseDataInner.md)
 - [GetReservationAssignmentsResponse](cloudbeds_pms_v1_3/docs/GetReservationAssignmentsResponse.md)
 - [GetReservationAssignmentsResponseDataInner](cloudbeds_pms_v1_3/docs/GetReservationAssignmentsResponseDataInner.md)
 - [GetReservationAssignmentsResponseDataInnerAssignedInner](cloudbeds_pms_v1_3/docs/GetReservationAssignmentsResponseDataInnerAssignedInner.md)
 - [GetReservationDeparturesResponse](cloudbeds_pms_v1_3/docs/GetReservationDeparturesResponse.md)
 - [GetReservationDeparturesResponseDataInner](cloudbeds_pms_v1_3/docs/GetReservationDeparturesResponseDataInner.md)
 - [GetReservationInHouseResponse](cloudbeds_pms_v1_3/docs/GetReservationInHouseResponse.md)
 - [GetReservationInHouseResponseDataInner](cloudbeds_pms_v1_3/docs/GetReservationInHouseResponseDataInner.md)
 - [GetReservationInvoiceInformationResponse](cloudbeds_pms_v1_3/docs/GetReservationInvoiceInformationResponse.md)
 - [GetReservationInvoiceInformationResponseDataInner](cloudbeds_pms_v1_3/docs/GetReservationInvoiceInformationResponseDataInner.md)
 - [GetReservationInvoiceInformationResponseDataInnerBalanceDetailedInner](cloudbeds_pms_v1_3/docs/GetReservationInvoiceInformationResponseDataInnerBalanceDetailedInner.md)
 - [GetReservationInvoiceInformationResponseDataInnerMainGuestDetailsInner](cloudbeds_pms_v1_3/docs/GetReservationInvoiceInformationResponseDataInnerMainGuestDetailsInner.md)
 - [GetReservationInvoiceInformationResponseDataInnerReservationAddOnProductsInner](cloudbeds_pms_v1_3/docs/GetReservationInvoiceInformationResponseDataInnerReservationAddOnProductsInner.md)
 - [GetReservationInvoiceInformationResponseDataInnerReservationAdditionalProductsInner](cloudbeds_pms_v1_3/docs/GetReservationInvoiceInformationResponseDataInnerReservationAdditionalProductsInner.md)
 - [GetReservationInvoiceInformationResponseDataInnerReservationAdjustmentsInner](cloudbeds_pms_v1_3/docs/GetReservationInvoiceInformationResponseDataInnerReservationAdjustmentsInner.md)
 - [GetReservationInvoiceInformationResponseDataInnerReservationPaymentsInner](cloudbeds_pms_v1_3/docs/GetReservationInvoiceInformationResponseDataInnerReservationPaymentsInner.md)
 - [GetReservationInvoiceInformationResponseDataInnerReservationRoomsInner](cloudbeds_pms_v1_3/docs/GetReservationInvoiceInformationResponseDataInnerReservationRoomsInner.md)
 - [GetReservationInvoiceInformationResponseDataInnerReservationTaxesInner](cloudbeds_pms_v1_3/docs/GetReservationInvoiceInformationResponseDataInnerReservationTaxesInner.md)
 - [GetReservationNotesResponse](cloudbeds_pms_v1_3/docs/GetReservationNotesResponse.md)
 - [GetReservationNotesResponseDataInner](cloudbeds_pms_v1_3/docs/GetReservationNotesResponseDataInner.md)
 - [GetReservationResponse](cloudbeds_pms_v1_3/docs/GetReservationResponse.md)
 - [GetReservationResponseData](cloudbeds_pms_v1_3/docs/GetReservationResponseData.md)
 - [GetReservationResponseDataAssignedInner](cloudbeds_pms_v1_3/docs/GetReservationResponseDataAssignedInner.md)
 - [GetReservationResponseDataAssignedInnerDailyRatesInner](cloudbeds_pms_v1_3/docs/GetReservationResponseDataAssignedInnerDailyRatesInner.md)
 - [GetReservationResponseDataBalanceDetailedInner](cloudbeds_pms_v1_3/docs/GetReservationResponseDataBalanceDetailedInner.md)
 - [GetReservationResponseDataCardsOnFileInner](cloudbeds_pms_v1_3/docs/GetReservationResponseDataCardsOnFileInner.md)
 - [GetReservationResponseDataGroupInventoryInner](cloudbeds_pms_v1_3/docs/GetReservationResponseDataGroupInventoryInner.md)
 - [GetReservationResponseDataGuestListValue](cloudbeds_pms_v1_3/docs/GetReservationResponseDataGuestListValue.md)
 - [GetReservationResponseDataGuestListValueCustomFieldsInner](cloudbeds_pms_v1_3/docs/GetReservationResponseDataGuestListValueCustomFieldsInner.md)
 - [GetReservationResponseDataGuestListValueRoomsInner](cloudbeds_pms_v1_3/docs/GetReservationResponseDataGuestListValueRoomsInner.md)
 - [GetReservationResponseDataGuestListValueUnassignedRoomsInner](cloudbeds_pms_v1_3/docs/GetReservationResponseDataGuestListValueUnassignedRoomsInner.md)
 - [GetReservationResponseDataUnassignedInner](cloudbeds_pms_v1_3/docs/GetReservationResponseDataUnassignedInner.md)
 - [GetReservationRoomDetailsResponse](cloudbeds_pms_v1_3/docs/GetReservationRoomDetailsResponse.md)
 - [GetReservationRoomDetailsResponseData](cloudbeds_pms_v1_3/docs/GetReservationRoomDetailsResponseData.md)
 - [GetReservationRoomDetailsResponseDataGuestsInner](cloudbeds_pms_v1_3/docs/GetReservationRoomDetailsResponseDataGuestsInner.md)
 - [GetReservationsResponse](cloudbeds_pms_v1_3/docs/GetReservationsResponse.md)
 - [GetReservationsResponseDataInner](cloudbeds_pms_v1_3/docs/GetReservationsResponseDataInner.md)
 - [GetReservationsResponseDataInnerGuestListValue](cloudbeds_pms_v1_3/docs/GetReservationsResponseDataInnerGuestListValue.md)
 - [GetReservationsResponseDataInnerGuestListValueRoomsInner](cloudbeds_pms_v1_3/docs/GetReservationsResponseDataInnerGuestListValueRoomsInner.md)
 - [GetReservationsResponseDataInnerGuestListValueUnassignedRoomsInner](cloudbeds_pms_v1_3/docs/GetReservationsResponseDataInnerGuestListValueUnassignedRoomsInner.md)
 - [GetReservationsResponseDataInnerRoomsInner](cloudbeds_pms_v1_3/docs/GetReservationsResponseDataInnerRoomsInner.md)
 - [GetReservationsWithRateDetailsResponse](cloudbeds_pms_v1_3/docs/GetReservationsWithRateDetailsResponse.md)
 - [GetReservationsWithRateDetailsResponseDataInner](cloudbeds_pms_v1_3/docs/GetReservationsWithRateDetailsResponseDataInner.md)
 - [GetReservationsWithRateDetailsResponseDataInnerRoomsInner](cloudbeds_pms_v1_3/docs/GetReservationsWithRateDetailsResponseDataInnerRoomsInner.md)
 - [GetReservationsWithRateDetailsResponseDataInnerSourceInner](cloudbeds_pms_v1_3/docs/GetReservationsWithRateDetailsResponseDataInnerSourceInner.md)
 - [GetRoomBlocksResponse](cloudbeds_pms_v1_3/docs/GetRoomBlocksResponse.md)
 - [GetRoomBlocksResponseDataInner](cloudbeds_pms_v1_3/docs/GetRoomBlocksResponseDataInner.md)
 - [GetRoomTypesResponse](cloudbeds_pms_v1_3/docs/GetRoomTypesResponse.md)
 - [GetRoomTypesResponseDataInner](cloudbeds_pms_v1_3/docs/GetRoomTypesResponseDataInner.md)
 - [GetRoomsFeesAndTaxesResponse](cloudbeds_pms_v1_3/docs/GetRoomsFeesAndTaxesResponse.md)
 - [GetRoomsFeesAndTaxesResponseData](cloudbeds_pms_v1_3/docs/GetRoomsFeesAndTaxesResponseData.md)
 - [GetRoomsFeesAndTaxesResponseDataFeesInner](cloudbeds_pms_v1_3/docs/GetRoomsFeesAndTaxesResponseDataFeesInner.md)
 - [GetRoomsFeesAndTaxesResponseDataTaxesInner](cloudbeds_pms_v1_3/docs/GetRoomsFeesAndTaxesResponseDataTaxesInner.md)
 - [GetRoomsResponse](cloudbeds_pms_v1_3/docs/GetRoomsResponse.md)
 - [GetRoomsResponseDataInner](cloudbeds_pms_v1_3/docs/GetRoomsResponseDataInner.md)
 - [GetRoomsResponseDataInnerRoomsInner](cloudbeds_pms_v1_3/docs/GetRoomsResponseDataInnerRoomsInner.md)
 - [GetRoomsResponseDataInnerRoomsInnerLinkedRoomTypeQtyInner](cloudbeds_pms_v1_3/docs/GetRoomsResponseDataInnerRoomsInnerLinkedRoomTypeQtyInner.md)
 - [GetRoomsUnassignedResponse](cloudbeds_pms_v1_3/docs/GetRoomsUnassignedResponse.md)
 - [GetRoomsUnassignedResponseDataInner](cloudbeds_pms_v1_3/docs/GetRoomsUnassignedResponseDataInner.md)
 - [GetRoomsUnassignedResponseDataInnerRoomsInner](cloudbeds_pms_v1_3/docs/GetRoomsUnassignedResponseDataInnerRoomsInner.md)
 - [GetSourcesResponse](cloudbeds_pms_v1_3/docs/GetSourcesResponse.md)
 - [GetSourcesResponseDataInner](cloudbeds_pms_v1_3/docs/GetSourcesResponseDataInner.md)
 - [GetSourcesResponseDataInnerFeesInner](cloudbeds_pms_v1_3/docs/GetSourcesResponseDataInnerFeesInner.md)
 - [GetSourcesResponseDataInnerTaxesInner](cloudbeds_pms_v1_3/docs/GetSourcesResponseDataInnerTaxesInner.md)
 - [GetTaxesAndFeesResponse](cloudbeds_pms_v1_3/docs/GetTaxesAndFeesResponse.md)
 - [GetTaxesAndFeesResponseDataInner](cloudbeds_pms_v1_3/docs/GetTaxesAndFeesResponseDataInner.md)
 - [GetTaxesAndFeesResponseDataInnerAmountRateBasedInner](cloudbeds_pms_v1_3/docs/GetTaxesAndFeesResponseDataInnerAmountRateBasedInner.md)
 - [GetTaxesAndFeesResponseDataInnerDateRangesInner](cloudbeds_pms_v1_3/docs/GetTaxesAndFeesResponseDataInnerDateRangesInner.md)
 - [GetTaxesAndFeesResponseDataInnerRoomTypesInner](cloudbeds_pms_v1_3/docs/GetTaxesAndFeesResponseDataInnerRoomTypesInner.md)
 - [GetTransactionsResponse](cloudbeds_pms_v1_3/docs/GetTransactionsResponse.md)
 - [GetTransactionsResponseDataInner](cloudbeds_pms_v1_3/docs/GetTransactionsResponseDataInner.md)
 - [GetUserinfoResponse](cloudbeds_pms_v1_3/docs/GetUserinfoResponse.md)
 - [GetUserinfoResponseRolesInner](cloudbeds_pms_v1_3/docs/GetUserinfoResponseRolesInner.md)
 - [GetUsersResponse](cloudbeds_pms_v1_3/docs/GetUsersResponse.md)
 - [GetUsersResponseDataInner](cloudbeds_pms_v1_3/docs/GetUsersResponseDataInner.md)
 - [GetUsersResponseDataInnerUserRole](cloudbeds_pms_v1_3/docs/GetUsersResponseDataInnerUserRole.md)
 - [GetWebhooksResponse](cloudbeds_pms_v1_3/docs/GetWebhooksResponse.md)
 - [GetWebhooksResponseDataInner](cloudbeds_pms_v1_3/docs/GetWebhooksResponseDataInner.md)
 - [GetWebhooksResponseDataInnerEvent](cloudbeds_pms_v1_3/docs/GetWebhooksResponseDataInnerEvent.md)
 - [GetWebhooksResponseDataInnerKey](cloudbeds_pms_v1_3/docs/GetWebhooksResponseDataInnerKey.md)
 - [GetWebhooksResponseDataInnerOwner](cloudbeds_pms_v1_3/docs/GetWebhooksResponseDataInnerOwner.md)
 - [GetWebhooksResponseDataInnerSubscriptionData](cloudbeds_pms_v1_3/docs/GetWebhooksResponseDataInnerSubscriptionData.md)
 - [PostAccessTokenCheckResponse](cloudbeds_pms_v1_3/docs/PostAccessTokenCheckResponse.md)
 - [PostAccessTokenResponse](cloudbeds_pms_v1_3/docs/PostAccessTokenResponse.md)
 - [PostAccessTokenResponseResourcesInner](cloudbeds_pms_v1_3/docs/PostAccessTokenResponseResourcesInner.md)
 - [PostAdjustmentResponse](cloudbeds_pms_v1_3/docs/PostAdjustmentResponse.md)
 - [PostAdjustmentResponseData](cloudbeds_pms_v1_3/docs/PostAdjustmentResponseData.md)
 - [PostAppErrorResponse](cloudbeds_pms_v1_3/docs/PostAppErrorResponse.md)
 - [PostAppErrorResponseData](cloudbeds_pms_v1_3/docs/PostAppErrorResponseData.md)
 - [PostAppPropertySettingResponse](cloudbeds_pms_v1_3/docs/PostAppPropertySettingResponse.md)
 - [PostAppPropertySettingResponseData](cloudbeds_pms_v1_3/docs/PostAppPropertySettingResponseData.md)
 - [PostAppSettingsRequestSettingsInner](cloudbeds_pms_v1_3/docs/PostAppSettingsRequestSettingsInner.md)
 - [PostAppSettingsResponse](cloudbeds_pms_v1_3/docs/PostAppSettingsResponse.md)
 - [PostAppStateInternalResponse](cloudbeds_pms_v1_3/docs/PostAppStateInternalResponse.md)
 - [PostAppStateResponse](cloudbeds_pms_v1_3/docs/PostAppStateResponse.md)
 - [PostAppendCustomItemResponse](cloudbeds_pms_v1_3/docs/PostAppendCustomItemResponse.md)
 - [PostAppendCustomItemResponseData](cloudbeds_pms_v1_3/docs/PostAppendCustomItemResponseData.md)
 - [PostBulkAppPropertySettingsResponse](cloudbeds_pms_v1_3/docs/PostBulkAppPropertySettingsResponse.md)
 - [PostCRMCacheRemoveResponse](cloudbeds_pms_v1_3/docs/PostCRMCacheRemoveResponse.md)
 - [PostCRMCacheUpdateResponse](cloudbeds_pms_v1_3/docs/PostCRMCacheUpdateResponse.md)
 - [PostCardResponse](cloudbeds_pms_v1_3/docs/PostCardResponse.md)
 - [PostCardResponseData](cloudbeds_pms_v1_3/docs/PostCardResponseData.md)
 - [PostChargeResponse](cloudbeds_pms_v1_3/docs/PostChargeResponse.md)
 - [PostChargeResponseData](cloudbeds_pms_v1_3/docs/PostChargeResponseData.md)
 - [PostChargeResponseDataNextAction](cloudbeds_pms_v1_3/docs/PostChargeResponseDataNextAction.md)
 - [PostChargeResponseDataNextActionDetails](cloudbeds_pms_v1_3/docs/PostChargeResponseDataNextActionDetails.md)
 - [PostCreateAllotmentBlockNotesResponse](cloudbeds_pms_v1_3/docs/PostCreateAllotmentBlockNotesResponse.md)
 - [PostCreateAllotmentBlockNotesResponseData](cloudbeds_pms_v1_3/docs/PostCreateAllotmentBlockNotesResponseData.md)
 - [PostCreateAllotmentBlockRequestAllotmentIntervalsInner](cloudbeds_pms_v1_3/docs/PostCreateAllotmentBlockRequestAllotmentIntervalsInner.md)
 - [PostCreateAllotmentBlockRequestAllotmentIntervalsInnerAvailabilityInner](cloudbeds_pms_v1_3/docs/PostCreateAllotmentBlockRequestAllotmentIntervalsInnerAvailabilityInner.md)
 - [PostCreateAllotmentBlockRequestAllotmentIntervalsInnerAvailabilityInnerGuestPricing](cloudbeds_pms_v1_3/docs/PostCreateAllotmentBlockRequestAllotmentIntervalsInnerAvailabilityInnerGuestPricing.md)
 - [PostCreateAllotmentBlockRequestAllotmentIntervalsInnerAvailabilityInnerRestrictions](cloudbeds_pms_v1_3/docs/PostCreateAllotmentBlockRequestAllotmentIntervalsInnerAvailabilityInnerRestrictions.md)
 - [PostCreateAllotmentBlockRequestAutoRelease](cloudbeds_pms_v1_3/docs/PostCreateAllotmentBlockRequestAutoRelease.md)
 - [PostCreateAllotmentBlockResponse](cloudbeds_pms_v1_3/docs/PostCreateAllotmentBlockResponse.md)
 - [PostCreateAllotmentBlockResponseDataInner](cloudbeds_pms_v1_3/docs/PostCreateAllotmentBlockResponseDataInner.md)
 - [PostCreateAllotmentBlockResponseDataInnerAllotmentIntervalsInner](cloudbeds_pms_v1_3/docs/PostCreateAllotmentBlockResponseDataInnerAllotmentIntervalsInner.md)
 - [PostCreateAllotmentBlockResponseDataInnerAllotmentIntervalsInnerAvailability](cloudbeds_pms_v1_3/docs/PostCreateAllotmentBlockResponseDataInnerAllotmentIntervalsInnerAvailability.md)
 - [PostCreateAllotmentBlockResponseDataInnerAllotmentIntervalsInnerAvailabilityGuestPricing](cloudbeds_pms_v1_3/docs/PostCreateAllotmentBlockResponseDataInnerAllotmentIntervalsInnerAvailabilityGuestPricing.md)
 - [PostCreateAllotmentBlockResponseDataInnerAllotmentIntervalsInnerRestrictions](cloudbeds_pms_v1_3/docs/PostCreateAllotmentBlockResponseDataInnerAllotmentIntervalsInnerRestrictions.md)
 - [PostCreateAllotmentBlockResponseDataInnerAutoRelease](cloudbeds_pms_v1_3/docs/PostCreateAllotmentBlockResponseDataInnerAutoRelease.md)
 - [PostCustomFieldResponse](cloudbeds_pms_v1_3/docs/PostCustomFieldResponse.md)
 - [PostCustomFieldResponseData](cloudbeds_pms_v1_3/docs/PostCustomFieldResponseData.md)
 - [PostCustomItemRequestItemsInner](cloudbeds_pms_v1_3/docs/PostCustomItemRequestItemsInner.md)
 - [PostCustomItemRequestItemsInnerItemFeesInner](cloudbeds_pms_v1_3/docs/PostCustomItemRequestItemsInnerItemFeesInner.md)
 - [PostCustomItemRequestItemsInnerItemTaxesInner](cloudbeds_pms_v1_3/docs/PostCustomItemRequestItemsInnerItemTaxesInner.md)
 - [PostCustomItemRequestPaymentsInner](cloudbeds_pms_v1_3/docs/PostCustomItemRequestPaymentsInner.md)
 - [PostCustomItemResponse](cloudbeds_pms_v1_3/docs/PostCustomItemResponse.md)
 - [PostCustomItemResponseData](cloudbeds_pms_v1_3/docs/PostCustomItemResponseData.md)
 - [PostCustomPaymentMethodResponse](cloudbeds_pms_v1_3/docs/PostCustomPaymentMethodResponse.md)
 - [PostDeleteAllotmentBlockResponse](cloudbeds_pms_v1_3/docs/PostDeleteAllotmentBlockResponse.md)
 - [PostDeleteAppPropertySettingsResponse](cloudbeds_pms_v1_3/docs/PostDeleteAppPropertySettingsResponse.md)
 - [PostEmailScheduleRequestSchedule](cloudbeds_pms_v1_3/docs/PostEmailScheduleRequestSchedule.md)
 - [PostEmailScheduleRequestScheduleReservationEvent](cloudbeds_pms_v1_3/docs/PostEmailScheduleRequestScheduleReservationEvent.md)
 - [PostEmailScheduleRequestScheduleReservationStatusChange](cloudbeds_pms_v1_3/docs/PostEmailScheduleRequestScheduleReservationStatusChange.md)
 - [PostEmailScheduleResponse](cloudbeds_pms_v1_3/docs/PostEmailScheduleResponse.md)
 - [PostEmailTemplateRequestBody](cloudbeds_pms_v1_3/docs/PostEmailTemplateRequestBody.md)
 - [PostEmailTemplateRequestSubject](cloudbeds_pms_v1_3/docs/PostEmailTemplateRequestSubject.md)
 - [PostEmailTemplateResponse](cloudbeds_pms_v1_3/docs/PostEmailTemplateResponse.md)
 - [PostFileResponse](cloudbeds_pms_v1_3/docs/PostFileResponse.md)
 - [PostGovernmentReceiptResponse](cloudbeds_pms_v1_3/docs/PostGovernmentReceiptResponse.md)
 - [PostGroupNoteResponse](cloudbeds_pms_v1_3/docs/PostGroupNoteResponse.md)
 - [PostGroupNoteResponseDataInner](cloudbeds_pms_v1_3/docs/PostGroupNoteResponseDataInner.md)
 - [PostGuestCreditCardResponse](cloudbeds_pms_v1_3/docs/PostGuestCreditCardResponse.md)
 - [PostGuestDocumentResponse](cloudbeds_pms_v1_3/docs/PostGuestDocumentResponse.md)
 - [PostGuestDocumentResponseData](cloudbeds_pms_v1_3/docs/PostGuestDocumentResponseData.md)
 - [PostGuestNoteResponse](cloudbeds_pms_v1_3/docs/PostGuestNoteResponse.md)
 - [PostGuestPhotoResponse](cloudbeds_pms_v1_3/docs/PostGuestPhotoResponse.md)
 - [PostGuestRequestCustomFieldsInner](cloudbeds_pms_v1_3/docs/PostGuestRequestCustomFieldsInner.md)
 - [PostGuestResponse](cloudbeds_pms_v1_3/docs/PostGuestResponse.md)
 - [PostGuestsToRoomResponse](cloudbeds_pms_v1_3/docs/PostGuestsToRoomResponse.md)
 - [PostHousekeeperResponse](cloudbeds_pms_v1_3/docs/PostHousekeeperResponse.md)
 - [PostHousekeepingAssignmentResponse](cloudbeds_pms_v1_3/docs/PostHousekeepingAssignmentResponse.md)
 - [PostHousekeepingStatusResponse](cloudbeds_pms_v1_3/docs/PostHousekeepingStatusResponse.md)
 - [PostHousekeepingStatusResponseData](cloudbeds_pms_v1_3/docs/PostHousekeepingStatusResponseData.md)
 - [PostItemCategoryResponse](cloudbeds_pms_v1_3/docs/PostItemCategoryResponse.md)
 - [PostItemResponse](cloudbeds_pms_v1_3/docs/PostItemResponse.md)
 - [PostItemToReservationRequestPaymentsInner](cloudbeds_pms_v1_3/docs/PostItemToReservationRequestPaymentsInner.md)
 - [PostItemToReservationResponse](cloudbeds_pms_v1_3/docs/PostItemToReservationResponse.md)
 - [PostItemToReservationResponseData](cloudbeds_pms_v1_3/docs/PostItemToReservationResponseData.md)
 - [PostItemsToInventoryRequestItem](cloudbeds_pms_v1_3/docs/PostItemsToInventoryRequestItem.md)
 - [PostItemsToInventoryResponse](cloudbeds_pms_v1_3/docs/PostItemsToInventoryResponse.md)
 - [PostItemsToInventoryResponseDataInner](cloudbeds_pms_v1_3/docs/PostItemsToInventoryResponseDataInner.md)
 - [PostNewHouseAccountResponse](cloudbeds_pms_v1_3/docs/PostNewHouseAccountResponse.md)
 - [PostNewHouseAccountResponseData](cloudbeds_pms_v1_3/docs/PostNewHouseAccountResponseData.md)
 - [PostPatchGroupResponse](cloudbeds_pms_v1_3/docs/PostPatchGroupResponse.md)
 - [PostPatchGroupResponseDataInner](cloudbeds_pms_v1_3/docs/PostPatchGroupResponseDataInner.md)
 - [PostPatchInvoiceResponse](cloudbeds_pms_v1_3/docs/PostPatchInvoiceResponse.md)
 - [PostPatchRateRequestRatesInner](cloudbeds_pms_v1_3/docs/PostPatchRateRequestRatesInner.md)
 - [PostPatchRateRequestRatesInnerInterval](cloudbeds_pms_v1_3/docs/PostPatchRateRequestRatesInnerInterval.md)
 - [PostPatchRateResponse](cloudbeds_pms_v1_3/docs/PostPatchRateResponse.md)
 - [PostPaymentCashResponse](cloudbeds_pms_v1_3/docs/PostPaymentCashResponse.md)
 - [PostPaymentCreditCardResponse](cloudbeds_pms_v1_3/docs/PostPaymentCreditCardResponse.md)
 - [PostPaymentResponse](cloudbeds_pms_v1_3/docs/PostPaymentResponse.md)
 - [PostPutAppPropertySettingsResponse](cloudbeds_pms_v1_3/docs/PostPutAppPropertySettingsResponse.md)
 - [PostPutGroupResponse](cloudbeds_pms_v1_3/docs/PostPutGroupResponse.md)
 - [PostPutRateRequest](cloudbeds_pms_v1_3/docs/PostPutRateRequest.md)
 - [PostPutRateRequestRatesInner](cloudbeds_pms_v1_3/docs/PostPutRateRequestRatesInner.md)
 - [PostPutRateRequestRatesInnerIntervalInner](cloudbeds_pms_v1_3/docs/PostPutRateRequestRatesInnerIntervalInner.md)
 - [PostPutRateResponse](cloudbeds_pms_v1_3/docs/PostPutRateResponse.md)
 - [PostReservationCheckInResponse](cloudbeds_pms_v1_3/docs/PostReservationCheckInResponse.md)
 - [PostReservationCheckOutResponse](cloudbeds_pms_v1_3/docs/PostReservationCheckOutResponse.md)
 - [PostReservationDocumentResponse](cloudbeds_pms_v1_3/docs/PostReservationDocumentResponse.md)
 - [PostReservationNoteResponse](cloudbeds_pms_v1_3/docs/PostReservationNoteResponse.md)
 - [PostReservationRequestAdultsInner](cloudbeds_pms_v1_3/docs/PostReservationRequestAdultsInner.md)
 - [PostReservationRequestChildrenInner](cloudbeds_pms_v1_3/docs/PostReservationRequestChildrenInner.md)
 - [PostReservationRequestCustomFieldsInner](cloudbeds_pms_v1_3/docs/PostReservationRequestCustomFieldsInner.md)
 - [PostReservationRequestRoomsInner](cloudbeds_pms_v1_3/docs/PostReservationRequestRoomsInner.md)
 - [PostReservationResponse](cloudbeds_pms_v1_3/docs/PostReservationResponse.md)
 - [PostReservationResponseUnassignedInner](cloudbeds_pms_v1_3/docs/PostReservationResponseUnassignedInner.md)
 - [PostRoomAssignResponse](cloudbeds_pms_v1_3/docs/PostRoomAssignResponse.md)
 - [PostRoomBlockRequestRoomsInner](cloudbeds_pms_v1_3/docs/PostRoomBlockRequestRoomsInner.md)
 - [PostRoomBlockResponse](cloudbeds_pms_v1_3/docs/PostRoomBlockResponse.md)
 - [PostRoomBlockResponseRoomsInner](cloudbeds_pms_v1_3/docs/PostRoomBlockResponseRoomsInner.md)
 - [PostRoomCheckInResponse](cloudbeds_pms_v1_3/docs/PostRoomCheckInResponse.md)
 - [PostRoomCheckOutResponse](cloudbeds_pms_v1_3/docs/PostRoomCheckOutResponse.md)
 - [PostRoomTypeResponse](cloudbeds_pms_v1_3/docs/PostRoomTypeResponse.md)
 - [PostRoomTypeResponseData](cloudbeds_pms_v1_3/docs/PostRoomTypeResponseData.md)
 - [PostUpdateAllotmentBlockNotesResponse](cloudbeds_pms_v1_3/docs/PostUpdateAllotmentBlockNotesResponse.md)
 - [PostUpdateAllotmentBlockNotesResponseData](cloudbeds_pms_v1_3/docs/PostUpdateAllotmentBlockNotesResponseData.md)
 - [PostUpdateAllotmentBlockRequestAllotmentIntervalsInner](cloudbeds_pms_v1_3/docs/PostUpdateAllotmentBlockRequestAllotmentIntervalsInner.md)
 - [PostUpdateAllotmentBlockRequestAllotmentIntervalsInnerAvailabilityInner](cloudbeds_pms_v1_3/docs/PostUpdateAllotmentBlockRequestAllotmentIntervalsInnerAvailabilityInner.md)
 - [PostUpdateAllotmentBlockRequestAllotmentIntervalsInnerAvailabilityInnerGuestPricing](cloudbeds_pms_v1_3/docs/PostUpdateAllotmentBlockRequestAllotmentIntervalsInnerAvailabilityInnerGuestPricing.md)
 - [PostUpdateAllotmentBlockRequestAllotmentIntervalsInnerAvailabilityInnerRestrictions](cloudbeds_pms_v1_3/docs/PostUpdateAllotmentBlockRequestAllotmentIntervalsInnerAvailabilityInnerRestrictions.md)
 - [PostUpdateAllotmentBlockRequestAutoRelease](cloudbeds_pms_v1_3/docs/PostUpdateAllotmentBlockRequestAutoRelease.md)
 - [PostUpdateAllotmentBlockResponse](cloudbeds_pms_v1_3/docs/PostUpdateAllotmentBlockResponse.md)
 - [PostUpdateAllotmentBlockResponseDataInner](cloudbeds_pms_v1_3/docs/PostUpdateAllotmentBlockResponseDataInner.md)
 - [PostUpdateAllotmentBlockResponseDataInnerAllotmentIntervalsInner](cloudbeds_pms_v1_3/docs/PostUpdateAllotmentBlockResponseDataInnerAllotmentIntervalsInner.md)
 - [PostUpdateAllotmentBlockResponseDataInnerAllotmentIntervalsInnerRestrictions](cloudbeds_pms_v1_3/docs/PostUpdateAllotmentBlockResponseDataInnerAllotmentIntervalsInnerRestrictions.md)
 - [PostVoidItemResponse](cloudbeds_pms_v1_3/docs/PostVoidItemResponse.md)
 - [PostVoidPaymentResponse](cloudbeds_pms_v1_3/docs/PostVoidPaymentResponse.md)
 - [PostWebhookResponse](cloudbeds_pms_v1_3/docs/PostWebhookResponse.md)
 - [PostWebhookResponseData](cloudbeds_pms_v1_3/docs/PostWebhookResponseData.md)
 - [PutGuestNoteResponse](cloudbeds_pms_v1_3/docs/PutGuestNoteResponse.md)
 - [PutGuestRequestGuestCustomFieldsInner](cloudbeds_pms_v1_3/docs/PutGuestRequestGuestCustomFieldsInner.md)
 - [PutGuestResponse](cloudbeds_pms_v1_3/docs/PutGuestResponse.md)
 - [PutHouseAccountStatusResponse](cloudbeds_pms_v1_3/docs/PutHouseAccountStatusResponse.md)
 - [PutHousekeeperResponse](cloudbeds_pms_v1_3/docs/PutHousekeeperResponse.md)
 - [PutItemToInventoryResponse](cloudbeds_pms_v1_3/docs/PutItemToInventoryResponse.md)
 - [PutRateRequestRatesInner](cloudbeds_pms_v1_3/docs/PutRateRequestRatesInner.md)
 - [PutRateRequestRatesInnerIntervalInner](cloudbeds_pms_v1_3/docs/PutRateRequestRatesInnerIntervalInner.md)
 - [PutRateResponse](cloudbeds_pms_v1_3/docs/PutRateResponse.md)
 - [PutReservationDetailsRequestCustomFieldsInner](cloudbeds_pms_v1_3/docs/PutReservationDetailsRequestCustomFieldsInner.md)
 - [PutReservationDetailsResponse](cloudbeds_pms_v1_3/docs/PutReservationDetailsResponse.md)
 - [PutReservationNoteResponse](cloudbeds_pms_v1_3/docs/PutReservationNoteResponse.md)
 - [PutReservationRequestCustomFieldsInner](cloudbeds_pms_v1_3/docs/PutReservationRequestCustomFieldsInner.md)
 - [PutReservationRequestRoomsInner](cloudbeds_pms_v1_3/docs/PutReservationRequestRoomsInner.md)
 - [PutReservationResponse](cloudbeds_pms_v1_3/docs/PutReservationResponse.md)
 - [PutRoomBlockRequestRoomsInner](cloudbeds_pms_v1_3/docs/PutRoomBlockRequestRoomsInner.md)
 - [PutRoomBlockResponse](cloudbeds_pms_v1_3/docs/PutRoomBlockResponse.md)


<a id="documentation-for-authorization"></a>
## Documentation For Authorization


Authentication schemes defined for the API:
<a id="api_key"></a>
### api_key

- **Type**: API key
- **API key parameter name**: x-api-key
- **Location**: HTTP header

<a id="OAuth2"></a>
### OAuth2

- **Type**: OAuth
- **Flow**: accessCode
- **Authorization URL**: 
- **Scopes**: 
 - **access_token**: access_token
 - **delete:adjustment**: delete:adjustment
 - **delete:appPropertySettings**: delete:appPropertySettings
 - **delete:item**: delete:item
 - **delete:roomblock**: delete:roomblock
 - **read:adjustment**: read:adjustment
 - **read:allotmentBlock**: read:allotmentBlock
 - **read:appPropertySettings**: read:appPropertySettings
 - **read:communication**: read:communication
 - **read:currency**: read:currency
 - **read:customFields**: read:customFields
 - **read:dashboard**: read:dashboard
 - **read:group**: read:group
 - **read:guest**: read:guest
 - **read:hotel**: read:hotel
 - **read:houseAccount**: read:houseAccount
 - **read:housekeeping**: read:housekeeping
 - **read:item**: read:item
 - **read:package**: read:package
 - **read:payment**: read:payment
 - **read:rate**: read:rate
 - **read:reservation**: read:reservation
 - **read:room**: read:room
 - **read:roomblock**: read:roomblock
 - **read:taxesAndFees**: read:taxesAndFees
 - **read:user**: read:user
 - **write:adjustment**: write:adjustment
 - **write:allotmentBlock**: write:allotmentBlock
 - **write:appError**: write:appError
 - **write:appPropertySettings**: write:appPropertySettings
 - **write:communication**: write:communication
 - **write:customFields**: write:customFields
 - **write:group**: write:group
 - **write:guest**: write:guest
 - **write:hotel**: write:hotel
 - **write:houseAccount**: write:houseAccount
 - **write:housekeeping**: write:housekeeping
 - **write:item**: write:item
 - **write:payment**: write:payment
 - **write:rate**: write:rate
 - **write:reservation**: write:reservation
 - **write:room**: write:room
 - **write:roomblock**: write:roomblock


## Author




