# coding: utf-8

"""
    Cloudbeds API

    <p>     Welcome to the documentation for <strong>Cloudbeds API Version v1.3</strong>!     If you are looking to learn how to use the Cloudbeds API to access guest information, reservations, or similar data     for your Cloudbeds customers, then you've come to the right place. </p>  <p>     In this document you will find all the API methods we provide along with explanations for parameters and response     examples. </p>  <p>     If you have questions about different implementation steps (e.g. how to implement OAuth 2.0), please refer to our     <a href=\"https://integrations.cloudbeds.com/hc/en-us\">Integrations Portal</a>. </p>  <p>     Be sure to <a href=\"https://go.pardot.com/l/308041/2018-07-24/qb2lg\">subscribe</a> to the monthly     Cloudbeds API announcement mailing list to receive information on new additions and improvements to the     Cloudbeds API and related developer tools. </p>  <p>     <strong>Endpoint:</strong> https://api.cloudbeds.com/api/v1.3/{method} </p>  <p>     <strong>HTTPS:</strong> Our API requires HTTPS. We'll respond with an appropriate error if you're not using it. </p>  <p>     <strong>Request Format:</strong> HTTP GET, POST and PUT (Content-Type: application/x-www-form-urlencoded) </p>  <p>     <strong>Response Format:</strong> JSON </p>  <p>     <strong>Response Header:</strong> X-Request-ID is added to response headers in all calls to help accelerate support     and troubleshooting. </p>  <p>     <strong>         <a href=\"https://integrations.cloudbeds.com/hc/en-us/articles/14104678058267-API-Documentation#postman-collection\">             <img src=\"https://run.pstmn.io/button.svg\" alt=\"Run in Postman\">         </a>     </strong> use this link to access our Public collection in Postman. </p>

    The version of the OpenAPI document: v1.3
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import date
from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictFloat, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional, Union
from cloudbeds_pms_v1_3.models.get_reservation_response_data_assigned_inner_daily_rates_inner import GetReservationResponseDataAssignedInnerDailyRatesInner
from typing import Optional, Set
from typing_extensions import Self

class GetReservationResponseDataAssignedInner(BaseModel):
    """
    GetReservationResponseDataAssignedInner
    """ # noqa: E501
    room_type_name: Optional[StrictStr] = Field(default=None, description="Name of the assigned room type", alias="roomTypeName")
    room_type_name_short: Optional[StrictStr] = Field(default=None, description="Short name of the assigned room type", alias="roomTypeNameShort")
    room_type_is_virtual: Optional[StrictBool] = Field(default=None, description="If room is virtual (true) or physical (false)", alias="roomTypeIsVirtual")
    dorm_room_name: Optional[StrictStr] = Field(default=None, description="Name of the dorm room. Used for the shared dorm beds that are organized into rooms within the same room type", alias="dormRoomName")
    room_type_id: Optional[StrictStr] = Field(default=None, description="ID of the assigned room type", alias="roomTypeID")
    sub_reservation_id: Optional[StrictStr] = Field(default=None, description="Sub Reservation ID of the specific assigned room", alias="subReservationID")
    room_name: Optional[StrictStr] = Field(default=None, description="Name of the specific assigned room", alias="roomName")
    room_id: Optional[StrictStr] = Field(default=None, description="ID of the specific assigned room", alias="roomID")
    start_date: Optional[date] = Field(default=None, description="Check-In date of the room", alias="startDate")
    end_date: Optional[date] = Field(default=None, description="Check-Out date of the room", alias="endDate")
    adults: Optional[StrictStr] = Field(default=None, description="Number of adult staying in the room")
    children: Optional[StrictStr] = Field(default=None, description="Number of children staying in the room")
    daily_rates: Optional[List[GetReservationResponseDataAssignedInnerDailyRatesInner]] = Field(default=None, description="Array with rates detailed by day", alias="dailyRates")
    room_total: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="Room total rate", alias="roomTotal")
    __properties: ClassVar[List[str]] = ["roomTypeName", "roomTypeNameShort", "roomTypeIsVirtual", "dormRoomName", "roomTypeID", "subReservationID", "roomName", "roomID", "startDate", "endDate", "adults", "children", "dailyRates", "roomTotal"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of GetReservationResponseDataAssignedInner from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in daily_rates (list)
        _items = []
        if self.daily_rates:
            for _item_daily_rates in self.daily_rates:
                if _item_daily_rates:
                    _items.append(_item_daily_rates.to_dict())
            _dict['dailyRates'] = _items
        # set to None if dorm_room_name (nullable) is None
        # and model_fields_set contains the field
        if self.dorm_room_name is None and "dorm_room_name" in self.model_fields_set:
            _dict['dormRoomName'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of GetReservationResponseDataAssignedInner from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "roomTypeName": obj.get("roomTypeName"),
            "roomTypeNameShort": obj.get("roomTypeNameShort"),
            "roomTypeIsVirtual": obj.get("roomTypeIsVirtual"),
            "dormRoomName": obj.get("dormRoomName"),
            "roomTypeID": obj.get("roomTypeID"),
            "subReservationID": obj.get("subReservationID"),
            "roomName": obj.get("roomName"),
            "roomID": obj.get("roomID"),
            "startDate": obj.get("startDate"),
            "endDate": obj.get("endDate"),
            "adults": obj.get("adults"),
            "children": obj.get("children"),
            "dailyRates": [GetReservationResponseDataAssignedInnerDailyRatesInner.from_dict(_item) for _item in obj["dailyRates"]] if obj.get("dailyRates") is not None else None,
            "roomTotal": obj.get("roomTotal")
        })
        return _obj


