# coding: utf-8

"""
    Cloudbeds API

    <p>     Welcome to the documentation for <strong>Cloudbeds API Version v1.3</strong>!     If you are looking to learn how to use the Cloudbeds API to access guest information, reservations, or similar data     for your Cloudbeds customers, then you've come to the right place. </p>  <p>     In this document you will find all the API methods we provide along with explanations for parameters and response     examples. </p>  <p>     If you have questions about different implementation steps (e.g. how to implement OAuth 2.0), please refer to our     <a href=\"https://integrations.cloudbeds.com/hc/en-us\">Integrations Portal</a>. </p>  <p>     Be sure to <a href=\"https://go.pardot.com/l/308041/2018-07-24/qb2lg\">subscribe</a> to the monthly     Cloudbeds API announcement mailing list to receive information on new additions and improvements to the     Cloudbeds API and related developer tools. </p>  <p>     <strong>Endpoint:</strong> https://api.cloudbeds.com/api/v1.3/{method} </p>  <p>     <strong>HTTPS:</strong> Our API requires HTTPS. We'll respond with an appropriate error if you're not using it. </p>  <p>     <strong>Request Format:</strong> HTTP GET, POST and PUT (Content-Type: application/x-www-form-urlencoded) </p>  <p>     <strong>Response Format:</strong> JSON </p>  <p>     <strong>Response Header:</strong> X-Request-ID is added to response headers in all calls to help accelerate support     and troubleshooting. </p>  <p>     <strong>         <a href=\"https://integrations.cloudbeds.com/hc/en-us/articles/14104678058267-API-Documentation#postman-collection\">             <img src=\"https://run.pstmn.io/button.svg\" alt=\"Run in Postman\">         </a>     </strong> use this link to access our Public collection in Postman. </p>

    The version of the OpenAPI document: v1.3
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictInt, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from cloudbeds_pms_v1_3.models.get_reservation_room_details_response_data_guests_inner import GetReservationRoomDetailsResponseDataGuestsInner
from typing import Optional, Set
from typing_extensions import Self

class GetReservationRoomDetailsResponseData(BaseModel):
    """
    Details for the rooms assigned on the selected date
    """ # noqa: E501
    reservation_id: Optional[StrictStr] = Field(default=None, description="Reservation Unique Identifier.", alias="reservationID")
    sub_reservation_id: Optional[StrictStr] = Field(default=None, description="Subreservation Unique Identifier", alias="subReservationID")
    room_id: Optional[StrictStr] = Field(default=None, description="ID of room assigned", alias="roomID")
    room_name: Optional[StrictStr] = Field(default=None, description="Name of room assigned", alias="roomName")
    dorm_room_name: Optional[StrictStr] = Field(default=None, description="Name of the dorm room. Used for the shared dorm beds that are organized into rooms within the same room type.", alias="dormRoomName")
    guest_id: Optional[StrictStr] = Field(default=None, description="Guest Identifier", alias="guestID")
    guest_name: Optional[StrictStr] = Field(default=None, description="Guest Name", alias="guestName")
    room_status: Optional[StrictStr] = Field(default=None, description="Room status<br /> 'cancelled' - Reservation with this room was canceled<br /> 'checked_out' - Guest already left the room<br /> 'in_house' - Guest is in the room<br /> 'not_checked_in' - Guest isn't checked-in yet", alias="roomStatus")
    room_type_id: Optional[StrictStr] = Field(default=None, description="ID of room type assigned", alias="roomTypeID")
    room_type_name: Optional[StrictStr] = Field(default=None, description="Name of room type assigned", alias="roomTypeName")
    room_type_is_virtual: Optional[StrictBool] = Field(default=None, description="If room is virtual (true) or physical (false)", alias="roomTypeIsVirtual")
    max_guests: Optional[StrictInt] = Field(default=None, description="Maximum number of guests that room type permits", alias="maxGuests")
    adults: Optional[StrictInt] = Field(default=None, description="Number of adults registered to room (this does not mean there will be this number of guests in guests array)")
    children: Optional[StrictInt] = Field(default=None, description="Number of children registered to room (this does not mean there will be this number of guests in guests array)")
    guests: Optional[List[GetReservationRoomDetailsResponseDataGuestsInner]] = Field(default=None, description="Array with all guests assigned to room")
    __properties: ClassVar[List[str]] = ["reservationID", "subReservationID", "roomID", "roomName", "dormRoomName", "guestID", "guestName", "roomStatus", "roomTypeID", "roomTypeName", "roomTypeIsVirtual", "maxGuests", "adults", "children", "guests"]

    @field_validator('room_status')
    def room_status_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['cancelled', 'checked_out', 'in_house', 'not_checked_in']):
            raise ValueError("must be one of enum values ('cancelled', 'checked_out', 'in_house', 'not_checked_in')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of GetReservationRoomDetailsResponseData from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in guests (list)
        _items = []
        if self.guests:
            for _item_guests in self.guests:
                if _item_guests:
                    _items.append(_item_guests.to_dict())
            _dict['guests'] = _items
        # set to None if dorm_room_name (nullable) is None
        # and model_fields_set contains the field
        if self.dorm_room_name is None and "dorm_room_name" in self.model_fields_set:
            _dict['dormRoomName'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of GetReservationRoomDetailsResponseData from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "reservationID": obj.get("reservationID"),
            "subReservationID": obj.get("subReservationID"),
            "roomID": obj.get("roomID"),
            "roomName": obj.get("roomName"),
            "dormRoomName": obj.get("dormRoomName"),
            "guestID": obj.get("guestID"),
            "guestName": obj.get("guestName"),
            "roomStatus": obj.get("roomStatus"),
            "roomTypeID": obj.get("roomTypeID"),
            "roomTypeName": obj.get("roomTypeName"),
            "roomTypeIsVirtual": obj.get("roomTypeIsVirtual"),
            "maxGuests": obj.get("maxGuests"),
            "adults": obj.get("adults"),
            "children": obj.get("children"),
            "guests": [GetReservationRoomDetailsResponseDataGuestsInner.from_dict(_item) for _item in obj["guests"]] if obj.get("guests") is not None else None
        })
        return _obj


