# coding: utf-8

"""
    Cloudbeds API

    <p>     Welcome to the documentation for <strong>Cloudbeds API Version v1.3</strong>!     If you are looking to learn how to use the Cloudbeds API to access guest information, reservations, or similar data     for your Cloudbeds customers, then you've come to the right place. </p>  <p>     In this document you will find all the API methods we provide along with explanations for parameters and response     examples. </p>  <p>     If you have questions about different implementation steps (e.g. how to implement OAuth 2.0), please refer to our     <a href=\"https://integrations.cloudbeds.com/hc/en-us\">Integrations Portal</a>. </p>  <p>     Be sure to <a href=\"https://go.pardot.com/l/308041/2018-07-24/qb2lg\">subscribe</a> to the monthly     Cloudbeds API announcement mailing list to receive information on new additions and improvements to the     Cloudbeds API and related developer tools. </p>  <p>     <strong>Endpoint:</strong> https://api.cloudbeds.com/api/v1.3/{method} </p>  <p>     <strong>HTTPS:</strong> Our API requires HTTPS. We'll respond with an appropriate error if you're not using it. </p>  <p>     <strong>Request Format:</strong> HTTP GET, POST and PUT (Content-Type: application/x-www-form-urlencoded) </p>  <p>     <strong>Response Format:</strong> JSON </p>  <p>     <strong>Response Header:</strong> X-Request-ID is added to response headers in all calls to help accelerate support     and troubleshooting. </p>  <p>     <strong>         <a href=\"https://integrations.cloudbeds.com/hc/en-us/articles/14104678058267-API-Documentation#postman-collection\">             <img src=\"https://run.pstmn.io/button.svg\" alt=\"Run in Postman\">         </a>     </strong> use this link to access our Public collection in Postman. </p>

    The version of the OpenAPI document: v1.3
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import date
from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from cloudbeds_pms_v1_3.models.get_guests_modified_response_data_inner_custom_fields_inner import GetGuestsModifiedResponseDataInnerCustomFieldsInner
from cloudbeds_pms_v1_3.models.get_reservations_response_data_inner_guest_list_value_rooms_inner import GetReservationsResponseDataInnerGuestListValueRoomsInner
from cloudbeds_pms_v1_3.models.get_reservations_response_data_inner_guest_list_value_unassigned_rooms_inner import GetReservationsResponseDataInnerGuestListValueUnassignedRoomsInner
from typing import Optional, Set
from typing_extensions import Self

class GetReservationsResponseDataInnerGuestListValue(BaseModel):
    """
    GetReservationsResponseDataInnerGuestListValue
    """ # noqa: E501
    guest_id: Optional[StrictStr] = Field(default=None, description="ID of the guest", alias="guestID")
    guest_name: Optional[StrictStr] = Field(default=None, alias="guestName")
    guest_first_name: Optional[StrictStr] = Field(default=None, alias="guestFirstName")
    guest_last_name: Optional[StrictStr] = Field(default=None, alias="guestLastName")
    guest_gender: Optional[StrictStr] = Field(default=None, alias="guestGender")
    guest_email: Optional[StrictStr] = Field(default=None, alias="guestEmail")
    guest_phone: Optional[StrictStr] = Field(default=None, alias="guestPhone")
    guest_cell_phone: Optional[StrictStr] = Field(default=None, alias="guestCellPhone")
    guest_address: Optional[StrictStr] = Field(default=None, alias="guestAddress")
    guest_address2: Optional[StrictStr] = Field(default=None, alias="guestAddress2")
    guest_city: Optional[StrictStr] = Field(default=None, alias="guestCity")
    guest_state: Optional[StrictStr] = Field(default=None, alias="guestState")
    guest_country: Optional[StrictStr] = Field(default=None, alias="guestCountry")
    guest_zip: Optional[StrictStr] = Field(default=None, alias="guestZip")
    guest_birthdate: Optional[date] = Field(default=None, alias="guestBirthdate")
    guest_document_type: Optional[StrictStr] = Field(default=None, alias="guestDocumentType")
    guest_document_number: Optional[StrictStr] = Field(default=None, alias="guestDocumentNumber")
    guest_document_issue_date: Optional[date] = Field(default=None, alias="guestDocumentIssueDate")
    guest_document_issuing_country: Optional[StrictStr] = Field(default=None, alias="guestDocumentIssuingCountry")
    guest_document_expiration_date: Optional[date] = Field(default=None, alias="guestDocumentExpirationDate")
    tax_id: Optional[StrictStr] = Field(default=None, description="Guest's tax ID", alias="taxID")
    company_tax_id: Optional[StrictStr] = Field(default=None, description="Guest's company tax ID", alias="companyTaxID")
    company_name: Optional[StrictStr] = Field(default=None, description="Guest's company name", alias="companyName")
    sub_reservation_id: Optional[StrictStr] = Field(default=None, alias="subReservationID")
    start_date: Optional[date] = Field(default=None, alias="startDate")
    end_date: Optional[date] = Field(default=None, alias="endDate")
    assigned_room: Optional[StrictStr] = Field(default=None, description="Returns true if guest has roomed assigned, false if not", alias="assignedRoom")
    room_id: Optional[StrictStr] = Field(default=None, description="Room ID where guest is assigned", alias="roomID")
    room_name: Optional[StrictStr] = Field(default=None, description="Room Name where guest is assigned", alias="roomName")
    room_type_name: Optional[StrictStr] = Field(default=None, description="Room Name where guest is assigned", alias="roomTypeName")
    room_type_is_virtual: Optional[StrictBool] = Field(default=None, description="If room is virtual (true) or physical (false)", alias="roomTypeIsVirtual")
    rooms: Optional[List[GetReservationsResponseDataInnerGuestListValueRoomsInner]] = Field(default=None, description="List of all rooms that guest is assigned to")
    unassigned_rooms: Optional[List[GetReservationsResponseDataInnerGuestListValueUnassignedRoomsInner]] = Field(default=None, description="List of all unassigned rooms", alias="unassignedRooms")
    custom_fields: Optional[List[GetGuestsModifiedResponseDataInnerCustomFieldsInner]] = Field(default=None, description="List of guest custom fields", alias="customFields")
    is_anonymized: Optional[StrictBool] = Field(default=None, description="Flag indicating the guest data was removed upon request", alias="isAnonymized")
    is_main_guest: Optional[StrictBool] = Field(default=None, description="Flag indicating the guest is the main guest on the reservation", alias="isMainGuest")
    __properties: ClassVar[List[str]] = ["guestID", "guestName", "guestFirstName", "guestLastName", "guestGender", "guestEmail", "guestPhone", "guestCellPhone", "guestAddress", "guestAddress2", "guestCity", "guestState", "guestCountry", "guestZip", "guestBirthdate", "guestDocumentType", "guestDocumentNumber", "guestDocumentIssueDate", "guestDocumentIssuingCountry", "guestDocumentExpirationDate", "taxID", "companyTaxID", "companyName", "subReservationID", "startDate", "endDate", "assignedRoom", "roomID", "roomName", "roomTypeName", "roomTypeIsVirtual", "rooms", "unassignedRooms", "customFields", "isAnonymized", "isMainGuest"]

    @field_validator('guest_gender')
    def guest_gender_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['M', 'F', 'N/A']):
            raise ValueError("must be one of enum values ('M', 'F', 'N/A')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of GetReservationsResponseDataInnerGuestListValue from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in rooms (list)
        _items = []
        if self.rooms:
            for _item_rooms in self.rooms:
                if _item_rooms:
                    _items.append(_item_rooms.to_dict())
            _dict['rooms'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in unassigned_rooms (list)
        _items = []
        if self.unassigned_rooms:
            for _item_unassigned_rooms in self.unassigned_rooms:
                if _item_unassigned_rooms:
                    _items.append(_item_unassigned_rooms.to_dict())
            _dict['unassignedRooms'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in custom_fields (list)
        _items = []
        if self.custom_fields:
            for _item_custom_fields in self.custom_fields:
                if _item_custom_fields:
                    _items.append(_item_custom_fields.to_dict())
            _dict['customFields'] = _items
        # set to None if guest_id (nullable) is None
        # and model_fields_set contains the field
        if self.guest_id is None and "guest_id" in self.model_fields_set:
            _dict['guestID'] = None

        # set to None if guest_name (nullable) is None
        # and model_fields_set contains the field
        if self.guest_name is None and "guest_name" in self.model_fields_set:
            _dict['guestName'] = None

        # set to None if guest_first_name (nullable) is None
        # and model_fields_set contains the field
        if self.guest_first_name is None and "guest_first_name" in self.model_fields_set:
            _dict['guestFirstName'] = None

        # set to None if guest_last_name (nullable) is None
        # and model_fields_set contains the field
        if self.guest_last_name is None and "guest_last_name" in self.model_fields_set:
            _dict['guestLastName'] = None

        # set to None if guest_gender (nullable) is None
        # and model_fields_set contains the field
        if self.guest_gender is None and "guest_gender" in self.model_fields_set:
            _dict['guestGender'] = None

        # set to None if guest_email (nullable) is None
        # and model_fields_set contains the field
        if self.guest_email is None and "guest_email" in self.model_fields_set:
            _dict['guestEmail'] = None

        # set to None if guest_phone (nullable) is None
        # and model_fields_set contains the field
        if self.guest_phone is None and "guest_phone" in self.model_fields_set:
            _dict['guestPhone'] = None

        # set to None if guest_cell_phone (nullable) is None
        # and model_fields_set contains the field
        if self.guest_cell_phone is None and "guest_cell_phone" in self.model_fields_set:
            _dict['guestCellPhone'] = None

        # set to None if guest_address (nullable) is None
        # and model_fields_set contains the field
        if self.guest_address is None and "guest_address" in self.model_fields_set:
            _dict['guestAddress'] = None

        # set to None if guest_address2 (nullable) is None
        # and model_fields_set contains the field
        if self.guest_address2 is None and "guest_address2" in self.model_fields_set:
            _dict['guestAddress2'] = None

        # set to None if guest_city (nullable) is None
        # and model_fields_set contains the field
        if self.guest_city is None and "guest_city" in self.model_fields_set:
            _dict['guestCity'] = None

        # set to None if guest_state (nullable) is None
        # and model_fields_set contains the field
        if self.guest_state is None and "guest_state" in self.model_fields_set:
            _dict['guestState'] = None

        # set to None if guest_country (nullable) is None
        # and model_fields_set contains the field
        if self.guest_country is None and "guest_country" in self.model_fields_set:
            _dict['guestCountry'] = None

        # set to None if guest_zip (nullable) is None
        # and model_fields_set contains the field
        if self.guest_zip is None and "guest_zip" in self.model_fields_set:
            _dict['guestZip'] = None

        # set to None if guest_birthdate (nullable) is None
        # and model_fields_set contains the field
        if self.guest_birthdate is None and "guest_birthdate" in self.model_fields_set:
            _dict['guestBirthdate'] = None

        # set to None if guest_document_type (nullable) is None
        # and model_fields_set contains the field
        if self.guest_document_type is None and "guest_document_type" in self.model_fields_set:
            _dict['guestDocumentType'] = None

        # set to None if guest_document_number (nullable) is None
        # and model_fields_set contains the field
        if self.guest_document_number is None and "guest_document_number" in self.model_fields_set:
            _dict['guestDocumentNumber'] = None

        # set to None if guest_document_issue_date (nullable) is None
        # and model_fields_set contains the field
        if self.guest_document_issue_date is None and "guest_document_issue_date" in self.model_fields_set:
            _dict['guestDocumentIssueDate'] = None

        # set to None if guest_document_issuing_country (nullable) is None
        # and model_fields_set contains the field
        if self.guest_document_issuing_country is None and "guest_document_issuing_country" in self.model_fields_set:
            _dict['guestDocumentIssuingCountry'] = None

        # set to None if guest_document_expiration_date (nullable) is None
        # and model_fields_set contains the field
        if self.guest_document_expiration_date is None and "guest_document_expiration_date" in self.model_fields_set:
            _dict['guestDocumentExpirationDate'] = None

        # set to None if tax_id (nullable) is None
        # and model_fields_set contains the field
        if self.tax_id is None and "tax_id" in self.model_fields_set:
            _dict['taxID'] = None

        # set to None if company_tax_id (nullable) is None
        # and model_fields_set contains the field
        if self.company_tax_id is None and "company_tax_id" in self.model_fields_set:
            _dict['companyTaxID'] = None

        # set to None if company_name (nullable) is None
        # and model_fields_set contains the field
        if self.company_name is None and "company_name" in self.model_fields_set:
            _dict['companyName'] = None

        # set to None if sub_reservation_id (nullable) is None
        # and model_fields_set contains the field
        if self.sub_reservation_id is None and "sub_reservation_id" in self.model_fields_set:
            _dict['subReservationID'] = None

        # set to None if start_date (nullable) is None
        # and model_fields_set contains the field
        if self.start_date is None and "start_date" in self.model_fields_set:
            _dict['startDate'] = None

        # set to None if end_date (nullable) is None
        # and model_fields_set contains the field
        if self.end_date is None and "end_date" in self.model_fields_set:
            _dict['endDate'] = None

        # set to None if assigned_room (nullable) is None
        # and model_fields_set contains the field
        if self.assigned_room is None and "assigned_room" in self.model_fields_set:
            _dict['assignedRoom'] = None

        # set to None if room_id (nullable) is None
        # and model_fields_set contains the field
        if self.room_id is None and "room_id" in self.model_fields_set:
            _dict['roomID'] = None

        # set to None if room_name (nullable) is None
        # and model_fields_set contains the field
        if self.room_name is None and "room_name" in self.model_fields_set:
            _dict['roomName'] = None

        # set to None if room_type_name (nullable) is None
        # and model_fields_set contains the field
        if self.room_type_name is None and "room_type_name" in self.model_fields_set:
            _dict['roomTypeName'] = None

        # set to None if room_type_is_virtual (nullable) is None
        # and model_fields_set contains the field
        if self.room_type_is_virtual is None and "room_type_is_virtual" in self.model_fields_set:
            _dict['roomTypeIsVirtual'] = None

        # set to None if rooms (nullable) is None
        # and model_fields_set contains the field
        if self.rooms is None and "rooms" in self.model_fields_set:
            _dict['rooms'] = None

        # set to None if unassigned_rooms (nullable) is None
        # and model_fields_set contains the field
        if self.unassigned_rooms is None and "unassigned_rooms" in self.model_fields_set:
            _dict['unassignedRooms'] = None

        # set to None if custom_fields (nullable) is None
        # and model_fields_set contains the field
        if self.custom_fields is None and "custom_fields" in self.model_fields_set:
            _dict['customFields'] = None

        # set to None if is_anonymized (nullable) is None
        # and model_fields_set contains the field
        if self.is_anonymized is None and "is_anonymized" in self.model_fields_set:
            _dict['isAnonymized'] = None

        # set to None if is_main_guest (nullable) is None
        # and model_fields_set contains the field
        if self.is_main_guest is None and "is_main_guest" in self.model_fields_set:
            _dict['isMainGuest'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of GetReservationsResponseDataInnerGuestListValue from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "guestID": obj.get("guestID"),
            "guestName": obj.get("guestName"),
            "guestFirstName": obj.get("guestFirstName"),
            "guestLastName": obj.get("guestLastName"),
            "guestGender": obj.get("guestGender"),
            "guestEmail": obj.get("guestEmail"),
            "guestPhone": obj.get("guestPhone"),
            "guestCellPhone": obj.get("guestCellPhone"),
            "guestAddress": obj.get("guestAddress"),
            "guestAddress2": obj.get("guestAddress2"),
            "guestCity": obj.get("guestCity"),
            "guestState": obj.get("guestState"),
            "guestCountry": obj.get("guestCountry"),
            "guestZip": obj.get("guestZip"),
            "guestBirthdate": obj.get("guestBirthdate"),
            "guestDocumentType": obj.get("guestDocumentType"),
            "guestDocumentNumber": obj.get("guestDocumentNumber"),
            "guestDocumentIssueDate": obj.get("guestDocumentIssueDate"),
            "guestDocumentIssuingCountry": obj.get("guestDocumentIssuingCountry"),
            "guestDocumentExpirationDate": obj.get("guestDocumentExpirationDate"),
            "taxID": obj.get("taxID"),
            "companyTaxID": obj.get("companyTaxID"),
            "companyName": obj.get("companyName"),
            "subReservationID": obj.get("subReservationID"),
            "startDate": obj.get("startDate"),
            "endDate": obj.get("endDate"),
            "assignedRoom": obj.get("assignedRoom"),
            "roomID": obj.get("roomID"),
            "roomName": obj.get("roomName"),
            "roomTypeName": obj.get("roomTypeName"),
            "roomTypeIsVirtual": obj.get("roomTypeIsVirtual"),
            "rooms": [GetReservationsResponseDataInnerGuestListValueRoomsInner.from_dict(_item) for _item in obj["rooms"]] if obj.get("rooms") is not None else None,
            "unassignedRooms": [GetReservationsResponseDataInnerGuestListValueUnassignedRoomsInner.from_dict(_item) for _item in obj["unassignedRooms"]] if obj.get("unassignedRooms") is not None else None,
            "customFields": [GetGuestsModifiedResponseDataInnerCustomFieldsInner.from_dict(_item) for _item in obj["customFields"]] if obj.get("customFields") is not None else None,
            "isAnonymized": obj.get("isAnonymized"),
            "isMainGuest": obj.get("isMainGuest")
        })
        return _obj


