# coding: utf-8

"""
    Cloudbeds API

    <p>     Welcome to the documentation for <strong>Cloudbeds API Version v1.3</strong>!     If you are looking to learn how to use the Cloudbeds API to access guest information, reservations, or similar data     for your Cloudbeds customers, then you've come to the right place. </p>  <p>     In this document you will find all the API methods we provide along with explanations for parameters and response     examples. </p>  <p>     If you have questions about different implementation steps (e.g. how to implement OAuth 2.0), please refer to our     <a href=\"https://integrations.cloudbeds.com/hc/en-us\">Integrations Portal</a>. </p>  <p>     Be sure to <a href=\"https://go.pardot.com/l/308041/2018-07-24/qb2lg\">subscribe</a> to the monthly     Cloudbeds API announcement mailing list to receive information on new additions and improvements to the     Cloudbeds API and related developer tools. </p>  <p>     <strong>Endpoint:</strong> https://api.cloudbeds.com/api/v1.3/{method} </p>  <p>     <strong>HTTPS:</strong> Our API requires HTTPS. We'll respond with an appropriate error if you're not using it. </p>  <p>     <strong>Request Format:</strong> HTTP GET, POST and PUT (Content-Type: application/x-www-form-urlencoded) </p>  <p>     <strong>Response Format:</strong> JSON </p>  <p>     <strong>Response Header:</strong> X-Request-ID is added to response headers in all calls to help accelerate support     and troubleshooting. </p>  <p>     <strong>         <a href=\"https://integrations.cloudbeds.com/hc/en-us/articles/14104678058267-API-Documentation#postman-collection\">             <img src=\"https://run.pstmn.io/button.svg\" alt=\"Run in Postman\">         </a>     </strong> use this link to access our Public collection in Postman. </p>

    The version of the OpenAPI document: v1.3
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class PostCreateAllotmentBlockRequestAllotmentIntervalsInnerAvailabilityInnerGuestPricing(BaseModel):
    """
    Guest pricing data if applicable. Note: the number of applicable keys varies here based on the occupancy settings for the room type.
    """ # noqa: E501
    adult1: Optional[StrictStr] = Field(default=None, description="Price for adult 1")
    adult2: Optional[StrictStr] = Field(default=None, description="Price for adult 2")
    adult3: Optional[StrictStr] = Field(default=None, description="Price for adult 3")
    child1: Optional[StrictStr] = Field(default=None, description="Price for child 1")
    child2: Optional[StrictStr] = Field(default=None, description="Price for child 2")
    child3: Optional[StrictStr] = Field(default=None, description="Price for child 3")
    __properties: ClassVar[List[str]] = ["adult1", "adult2", "adult3", "child1", "child2", "child3"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of PostCreateAllotmentBlockRequestAllotmentIntervalsInnerAvailabilityInnerGuestPricing from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # set to None if adult1 (nullable) is None
        # and model_fields_set contains the field
        if self.adult1 is None and "adult1" in self.model_fields_set:
            _dict['adult1'] = None

        # set to None if adult2 (nullable) is None
        # and model_fields_set contains the field
        if self.adult2 is None and "adult2" in self.model_fields_set:
            _dict['adult2'] = None

        # set to None if adult3 (nullable) is None
        # and model_fields_set contains the field
        if self.adult3 is None and "adult3" in self.model_fields_set:
            _dict['adult3'] = None

        # set to None if child1 (nullable) is None
        # and model_fields_set contains the field
        if self.child1 is None and "child1" in self.model_fields_set:
            _dict['child1'] = None

        # set to None if child2 (nullable) is None
        # and model_fields_set contains the field
        if self.child2 is None and "child2" in self.model_fields_set:
            _dict['child2'] = None

        # set to None if child3 (nullable) is None
        # and model_fields_set contains the field
        if self.child3 is None and "child3" in self.model_fields_set:
            _dict['child3'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of PostCreateAllotmentBlockRequestAllotmentIntervalsInnerAvailabilityInnerGuestPricing from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "adult1": obj.get("adult1"),
            "adult2": obj.get("adult2"),
            "adult3": obj.get("adult3"),
            "child1": obj.get("child1"),
            "child2": obj.get("child2"),
            "child3": obj.get("child3")
        })
        return _obj


