# coding: utf-8

"""
    Cloudbeds API

    <p>     Welcome to the documentation for <strong>Cloudbeds API Version v1.3</strong>!     If you are looking to learn how to use the Cloudbeds API to access guest information, reservations, or similar data     for your Cloudbeds customers, then you've come to the right place. </p>  <p>     In this document you will find all the API methods we provide along with explanations for parameters and response     examples. </p>  <p>     If you have questions about different implementation steps (e.g. how to implement OAuth 2.0), please refer to our     <a href=\"https://integrations.cloudbeds.com/hc/en-us\">Integrations Portal</a>. </p>  <p>     Be sure to <a href=\"https://go.pardot.com/l/308041/2018-07-24/qb2lg\">subscribe</a> to the monthly     Cloudbeds API announcement mailing list to receive information on new additions and improvements to the     Cloudbeds API and related developer tools. </p>  <p>     <strong>Endpoint:</strong> https://api.cloudbeds.com/api/v1.3/{method} </p>  <p>     <strong>HTTPS:</strong> Our API requires HTTPS. We'll respond with an appropriate error if you're not using it. </p>  <p>     <strong>Request Format:</strong> HTTP GET, POST and PUT (Content-Type: application/x-www-form-urlencoded) </p>  <p>     <strong>Response Format:</strong> JSON </p>  <p>     <strong>Response Header:</strong> X-Request-ID is added to response headers in all calls to help accelerate support     and troubleshooting. </p>  <p>     <strong>         <a href=\"https://integrations.cloudbeds.com/hc/en-us/articles/14104678058267-API-Documentation#postman-collection\">             <img src=\"https://run.pstmn.io/button.svg\" alt=\"Run in Postman\">         </a>     </strong> use this link to access our Public collection in Postman. </p>

    The version of the OpenAPI document: v1.3
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictFloat, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional, Union
from cloudbeds_pms_v1_3.models.post_custom_item_request_items_inner_item_fees_inner import PostCustomItemRequestItemsInnerItemFeesInner
from cloudbeds_pms_v1_3.models.post_custom_item_request_items_inner_item_taxes_inner import PostCustomItemRequestItemsInnerItemTaxesInner
from typing import Optional, Set
from typing_extensions import Self

class PostCustomItemRequestItemsInner(BaseModel):
    """
    PostCustomItemRequestItemsInner
    """ # noqa: E501
    app_item_id: Optional[StrictStr] = Field(default=None, description="Identifier of item. Future calls using the same ID will use previously sent item name and description. Item name/description sent in new request will be ignored.", alias="appItemID")
    item_sku: Optional[StrictStr] = Field(default=None, description="Item SKU identifier", alias="itemSKU")
    item_quantity: Optional[StrictInt] = Field(default=None, description="Items quantity", alias="itemQuantity")
    item_price: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="Item price", alias="itemPrice")
    item_name: Optional[StrictStr] = Field(default=None, description="Item name", alias="itemName")
    item_category_name: Optional[StrictStr] = Field(default=None, description="Item category name", alias="itemCategoryName")
    item_note: Optional[StrictStr] = Field(default=None, description="Item note", alias="itemNote")
    item_taxes: Optional[List[PostCustomItemRequestItemsInnerItemTaxesInner]] = Field(default=None, description="list of taxes applied to item", alias="itemTaxes")
    item_fees: Optional[List[PostCustomItemRequestItemsInnerItemFeesInner]] = Field(default=None, description="list of fees applied to item", alias="itemFees")
    __properties: ClassVar[List[str]] = ["appItemID", "itemSKU", "itemQuantity", "itemPrice", "itemName", "itemCategoryName", "itemNote", "itemTaxes", "itemFees"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of PostCustomItemRequestItemsInner from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in item_taxes (list)
        _items = []
        if self.item_taxes:
            for _item_item_taxes in self.item_taxes:
                if _item_item_taxes:
                    _items.append(_item_item_taxes.to_dict())
            _dict['itemTaxes'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in item_fees (list)
        _items = []
        if self.item_fees:
            for _item_item_fees in self.item_fees:
                if _item_item_fees:
                    _items.append(_item_item_fees.to_dict())
            _dict['itemFees'] = _items
        # set to None if item_sku (nullable) is None
        # and model_fields_set contains the field
        if self.item_sku is None and "item_sku" in self.model_fields_set:
            _dict['itemSKU'] = None

        # set to None if item_category_name (nullable) is None
        # and model_fields_set contains the field
        if self.item_category_name is None and "item_category_name" in self.model_fields_set:
            _dict['itemCategoryName'] = None

        # set to None if item_note (nullable) is None
        # and model_fields_set contains the field
        if self.item_note is None and "item_note" in self.model_fields_set:
            _dict['itemNote'] = None

        # set to None if item_taxes (nullable) is None
        # and model_fields_set contains the field
        if self.item_taxes is None and "item_taxes" in self.model_fields_set:
            _dict['itemTaxes'] = None

        # set to None if item_fees (nullable) is None
        # and model_fields_set contains the field
        if self.item_fees is None and "item_fees" in self.model_fields_set:
            _dict['itemFees'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of PostCustomItemRequestItemsInner from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "appItemID": obj.get("appItemID"),
            "itemSKU": obj.get("itemSKU"),
            "itemQuantity": obj.get("itemQuantity"),
            "itemPrice": obj.get("itemPrice"),
            "itemName": obj.get("itemName"),
            "itemCategoryName": obj.get("itemCategoryName"),
            "itemNote": obj.get("itemNote"),
            "itemTaxes": [PostCustomItemRequestItemsInnerItemTaxesInner.from_dict(_item) for _item in obj["itemTaxes"]] if obj.get("itemTaxes") is not None else None,
            "itemFees": [PostCustomItemRequestItemsInnerItemFeesInner.from_dict(_item) for _item in obj["itemFees"]] if obj.get("itemFees") is not None else None
        })
        return _obj


