# coding: utf-8

"""
    Cloudbeds API

    <p>     Welcome to the documentation for <strong>Cloudbeds API Version v1.3</strong>!     If you are looking to learn how to use the Cloudbeds API to access guest information, reservations, or similar data     for your Cloudbeds customers, then you've come to the right place. </p>  <p>     In this document you will find all the API methods we provide along with explanations for parameters and response     examples. </p>  <p>     If you have questions about different implementation steps (e.g. how to implement OAuth 2.0), please refer to our     <a href=\"https://integrations.cloudbeds.com/hc/en-us\">Integrations Portal</a>. </p>  <p>     Be sure to <a href=\"https://go.pardot.com/l/308041/2018-07-24/qb2lg\">subscribe</a> to the monthly     Cloudbeds API announcement mailing list to receive information on new additions and improvements to the     Cloudbeds API and related developer tools. </p>  <p>     <strong>Endpoint:</strong> https://api.cloudbeds.com/api/v1.3/{method} </p>  <p>     <strong>HTTPS:</strong> Our API requires HTTPS. We'll respond with an appropriate error if you're not using it. </p>  <p>     <strong>Request Format:</strong> HTTP GET, POST and PUT (Content-Type: application/x-www-form-urlencoded) </p>  <p>     <strong>Response Format:</strong> JSON </p>  <p>     <strong>Response Header:</strong> X-Request-ID is added to response headers in all calls to help accelerate support     and troubleshooting. </p>  <p>     <strong>         <a href=\"https://integrations.cloudbeds.com/hc/en-us/articles/14104678058267-API-Documentation#postman-collection\">             <img src=\"https://run.pstmn.io/button.svg\" alt=\"Run in Postman\">         </a>     </strong> use this link to access our Public collection in Postman. </p>

    The version of the OpenAPI document: v1.3
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import date
from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class PostHousekeepingStatusResponseData(BaseModel):
    """
    
    """ # noqa: E501
    var_date: Optional[date] = Field(default=None, description="Date for last date/time that the room condition changed", alias="date")
    room_id: Optional[StrictStr] = Field(default=None, description="ID of room", alias="roomID")
    room_condition: Optional[StrictStr] = Field(default=None, description="New room condition. \"inspected\" status is available only if the property has the feature enabled.", alias="roomCondition")
    room_comments: Optional[StrictStr] = Field(default=None, description="New room comments.", alias="roomComments")
    do_not_disturb: Optional[StrictBool] = Field(default=None, description="New \"do not disturb\" status", alias="doNotDisturb")
    refused_service: Optional[StrictBool] = Field(default=None, description="New \"refused service\" status", alias="refusedService")
    vacant_pickup: Optional[StrictBool] = Field(default=None, description="New \"vacant_pickup\" status", alias="vacantPickup")
    __properties: ClassVar[List[str]] = ["date", "roomID", "roomCondition", "roomComments", "doNotDisturb", "refusedService", "vacantPickup"]

    @field_validator('room_condition')
    def room_condition_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['dirty', 'clean', 'inspected']):
            raise ValueError("must be one of enum values ('dirty', 'clean', 'inspected')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of PostHousekeepingStatusResponseData from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # set to None if do_not_disturb (nullable) is None
        # and model_fields_set contains the field
        if self.do_not_disturb is None and "do_not_disturb" in self.model_fields_set:
            _dict['doNotDisturb'] = None

        # set to None if refused_service (nullable) is None
        # and model_fields_set contains the field
        if self.refused_service is None and "refused_service" in self.model_fields_set:
            _dict['refusedService'] = None

        # set to None if vacant_pickup (nullable) is None
        # and model_fields_set contains the field
        if self.vacant_pickup is None and "vacant_pickup" in self.model_fields_set:
            _dict['vacantPickup'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of PostHousekeepingStatusResponseData from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "date": obj.get("date"),
            "roomID": obj.get("roomID"),
            "roomCondition": obj.get("roomCondition"),
            "roomComments": obj.get("roomComments"),
            "doNotDisturb": obj.get("doNotDisturb"),
            "refusedService": obj.get("refusedService"),
            "vacantPickup": obj.get("vacantPickup")
        })
        return _obj


