# coding: utf-8

"""
    Cloudbeds API

    <p>     Welcome to the documentation for <strong>Cloudbeds API Version v1.3</strong>!     If you are looking to learn how to use the Cloudbeds API to access guest information, reservations, or similar data     for your Cloudbeds customers, then you've come to the right place. </p>  <p>     In this document you will find all the API methods we provide along with explanations for parameters and response     examples. </p>  <p>     If you have questions about different implementation steps (e.g. how to implement OAuth 2.0), please refer to our     <a href=\"https://integrations.cloudbeds.com/hc/en-us\">Integrations Portal</a>. </p>  <p>     Be sure to <a href=\"https://go.pardot.com/l/308041/2018-07-24/qb2lg\">subscribe</a> to the monthly     Cloudbeds API announcement mailing list to receive information on new additions and improvements to the     Cloudbeds API and related developer tools. </p>  <p>     <strong>Endpoint:</strong> https://api.cloudbeds.com/api/v1.3/{method} </p>  <p>     <strong>HTTPS:</strong> Our API requires HTTPS. We'll respond with an appropriate error if you're not using it. </p>  <p>     <strong>Request Format:</strong> HTTP GET, POST and PUT (Content-Type: application/x-www-form-urlencoded) </p>  <p>     <strong>Response Format:</strong> JSON </p>  <p>     <strong>Response Header:</strong> X-Request-ID is added to response headers in all calls to help accelerate support     and troubleshooting. </p>  <p>     <strong>         <a href=\"https://integrations.cloudbeds.com/hc/en-us/articles/14104678058267-API-Documentation#postman-collection\">             <img src=\"https://run.pstmn.io/button.svg\" alt=\"Run in Postman\">         </a>     </strong> use this link to access our Public collection in Postman. </p>

    The version of the OpenAPI document: v1.3
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import date
from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictFloat, StrictInt
from typing import Any, ClassVar, Dict, List, Optional, Union
from cloudbeds_pms_v1_3.models.post_create_allotment_block_request_allotment_intervals_inner_availability_inner_guest_pricing import PostCreateAllotmentBlockRequestAllotmentIntervalsInnerAvailabilityInnerGuestPricing
from typing import Optional, Set
from typing_extensions import Self

class PostPatchRateRequestRatesInnerInterval(BaseModel):
    """
    Rate update details
    """ # noqa: E501
    start_date: Optional[date] = Field(default=None, description="Interval Start date. Format: YYYY-MM-DD", alias="startDate")
    end_date: Optional[date] = Field(default=None, description="Interval End date. Format: YYYY-MM-DD", alias="endDate")
    rate: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="Base rate for the selected date")
    max_los: Optional[StrictInt] = Field(default=None, description="Maximum length of stay for the selected date.", alias="maxLos")
    min_los: Optional[StrictInt] = Field(default=None, description="Minimum length of stay for the selected date.", alias="minLos")
    closed_to_arrival: Optional[StrictBool] = Field(default=None, description="Whether it is closed to arrival.", alias="closedToArrival")
    closed_to_departure: Optional[StrictBool] = Field(default=None, description="Whether it is closed to departure.", alias="closedToDeparture")
    cut_off: Optional[StrictInt] = Field(default=None, description="Cut off time for the selected date.", alias="cutOff")
    last_minute_booking: Optional[StrictInt] = Field(default=None, description="Last minute bookings.", alias="lastMinuteBooking")
    blocked: Optional[StrictBool] = Field(default=None, description="Whether the accommodation is blocked.")
    guest_pricing: Optional[PostCreateAllotmentBlockRequestAllotmentIntervalsInnerAvailabilityInnerGuestPricing] = Field(default=None, alias="guestPricing")
    __properties: ClassVar[List[str]] = ["startDate", "endDate", "rate", "maxLos", "minLos", "closedToArrival", "closedToDeparture", "cutOff", "lastMinuteBooking", "blocked", "guestPricing"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of PostPatchRateRequestRatesInnerInterval from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of guest_pricing
        if self.guest_pricing:
            _dict['guestPricing'] = self.guest_pricing.to_dict()
        # set to None if max_los (nullable) is None
        # and model_fields_set contains the field
        if self.max_los is None and "max_los" in self.model_fields_set:
            _dict['maxLos'] = None

        # set to None if min_los (nullable) is None
        # and model_fields_set contains the field
        if self.min_los is None and "min_los" in self.model_fields_set:
            _dict['minLos'] = None

        # set to None if closed_to_arrival (nullable) is None
        # and model_fields_set contains the field
        if self.closed_to_arrival is None and "closed_to_arrival" in self.model_fields_set:
            _dict['closedToArrival'] = None

        # set to None if closed_to_departure (nullable) is None
        # and model_fields_set contains the field
        if self.closed_to_departure is None and "closed_to_departure" in self.model_fields_set:
            _dict['closedToDeparture'] = None

        # set to None if cut_off (nullable) is None
        # and model_fields_set contains the field
        if self.cut_off is None and "cut_off" in self.model_fields_set:
            _dict['cutOff'] = None

        # set to None if last_minute_booking (nullable) is None
        # and model_fields_set contains the field
        if self.last_minute_booking is None and "last_minute_booking" in self.model_fields_set:
            _dict['lastMinuteBooking'] = None

        # set to None if blocked (nullable) is None
        # and model_fields_set contains the field
        if self.blocked is None and "blocked" in self.model_fields_set:
            _dict['blocked'] = None

        # set to None if guest_pricing (nullable) is None
        # and model_fields_set contains the field
        if self.guest_pricing is None and "guest_pricing" in self.model_fields_set:
            _dict['guestPricing'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of PostPatchRateRequestRatesInnerInterval from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "startDate": obj.get("startDate"),
            "endDate": obj.get("endDate"),
            "rate": obj.get("rate"),
            "maxLos": obj.get("maxLos"),
            "minLos": obj.get("minLos"),
            "closedToArrival": obj.get("closedToArrival"),
            "closedToDeparture": obj.get("closedToDeparture"),
            "cutOff": obj.get("cutOff"),
            "lastMinuteBooking": obj.get("lastMinuteBooking"),
            "blocked": obj.get("blocked"),
            "guestPricing": PostCreateAllotmentBlockRequestAllotmentIntervalsInnerAvailabilityInnerGuestPricing.from_dict(obj["guestPricing"]) if obj.get("guestPricing") is not None else None
        })
        return _obj


