# coding: utf-8

"""
    Cloudbeds API

    <p>     Welcome to the documentation for <strong>Cloudbeds API Version v1.3</strong>!     If you are looking to learn how to use the Cloudbeds API to access guest information, reservations, or similar data     for your Cloudbeds customers, then you've come to the right place. </p>  <p>     In this document you will find all the API methods we provide along with explanations for parameters and response     examples. </p>  <p>     If you have questions about different implementation steps (e.g. how to implement OAuth 2.0), please refer to our     <a href=\"https://integrations.cloudbeds.com/hc/en-us\">Integrations Portal</a>. </p>  <p>     Be sure to <a href=\"https://go.pardot.com/l/308041/2018-07-24/qb2lg\">subscribe</a> to the monthly     Cloudbeds API announcement mailing list to receive information on new additions and improvements to the     Cloudbeds API and related developer tools. </p>  <p>     <strong>Endpoint:</strong> https://api.cloudbeds.com/api/v1.3/{method} </p>  <p>     <strong>HTTPS:</strong> Our API requires HTTPS. We'll respond with an appropriate error if you're not using it. </p>  <p>     <strong>Request Format:</strong> HTTP GET, POST and PUT (Content-Type: application/x-www-form-urlencoded) </p>  <p>     <strong>Response Format:</strong> JSON </p>  <p>     <strong>Response Header:</strong> X-Request-ID is added to response headers in all calls to help accelerate support     and troubleshooting. </p>  <p>     <strong>         <a href=\"https://integrations.cloudbeds.com/hc/en-us/articles/14104678058267-API-Documentation#postman-collection\">             <img src=\"https://run.pstmn.io/button.svg\" alt=\"Run in Postman\">         </a>     </strong> use this link to access our Public collection in Postman. </p>

    The version of the OpenAPI document: v1.3
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


import unittest

from cloudbeds_pms_v1_3.models.get_reservation_response import GetReservationResponse

class TestGetReservationResponse(unittest.TestCase):
    """GetReservationResponse unit test stubs"""

    def setUp(self):
        pass

    def tearDown(self):
        pass

    def make_instance(self, include_optional) -> GetReservationResponse:
        """Test GetReservationResponse
            include_optional is a boolean, when False only required
            params are included, when True both required and
            optional params are included """
        # uncomment below to create an instance of `GetReservationResponse`
        """
        model = GetReservationResponse()
        if include_optional:
            return GetReservationResponse(
                success = True,
                data = cloudbeds_pms_v1_3.models.get_reservation_response_data.GetReservationResponse_data(
                    property_id = '', 
                    guest_name = '', 
                    guest_email = '', 
                    is_anonymized = True, 
                    guest_list = {
                        'key' : cloudbeds_pms_v1_3.models.get_reservation_response_data_guest_list_value.GetReservationResponse_data_guestList_value(
                            guest_id = '', 
                            guest_first_name = '', 
                            guest_last_name = '', 
                            guest_gender = 'M', 
                            guest_email = '', 
                            guest_phone = '', 
                            guest_cell_phone = '', 
                            guest_address = '', 
                            guest_address2 = '', 
                            guest_city = '', 
                            guest_state = '', 
                            guest_country = '', 
                            guest_zip = '', 
                            guest_status = 'in_progress', 
                            guest_birthdate = datetime.datetime.strptime('1975-12-30', '%Y-%m-%d').date(), 
                            guest_document_type = '', 
                            guest_document_number = '', 
                            guest_document_issue_date = datetime.datetime.strptime('1975-12-30', '%Y-%m-%d').date(), 
                            guest_document_issuing_country = '', 
                            guest_document_expiration_date = datetime.datetime.strptime('1975-12-30', '%Y-%m-%d').date(), 
                            tax_id = '', 
                            company_tax_id = '', 
                            company_name = '', 
                            assigned_room = '', 
                            is_anonymized = True, 
                            room_id = '', 
                            room_name = '', 
                            room_type_name = '', 
                            room_type_is_virtual = True, 
                            is_main_guest = True, 
                            custom_fields = [
                                cloudbeds_pms_v1_3.models.get_reservation_response_data_guest_list_value_custom_fields_inner.GetReservationResponse_data_guestList_value_customFields_inner(
                                    custom_field_name = '', 
                                    custom_field_value = '', )
                                ], 
                            rooms = [
                                cloudbeds_pms_v1_3.models.get_reservation_response_data_guest_list_value_rooms_inner.GetReservationResponse_data_guestList_value_rooms_inner(
                                    room_id = '', 
                                    room_name = '', 
                                    room_type_name = '', 
                                    room_type_is_virtual = True, 
                                    sub_reservation_id = '', )
                                ], 
                            unassigned_rooms = [
                                cloudbeds_pms_v1_3.models.get_reservation_response_data_guest_list_value_unassigned_rooms_inner.GetReservationResponse_data_guestList_value_unassignedRooms_inner(
                                    room_type_id = '', 
                                    room_type_name = '', 
                                    room_type_is_virtual = True, 
                                    sub_reservation_id = '', )
                                ], )
                        }, 
                    reservation_id = '', 
                    date_created = datetime.datetime.strptime('2013-10-20 19:20:30.00', '%Y-%m-%d %H:%M:%S.%f'), 
                    date_modified = datetime.datetime.strptime('2013-10-20 19:20:30.00', '%Y-%m-%d %H:%M:%S.%f'), 
                    estimated_arrival_time = '', 
                    source = '', 
                    source_id = '', 
                    third_party_identifier = '', 
                    status = 'confirmed', 
                    total = 1.337, 
                    balance = 1.337, 
                    balance_detailed = [
                        cloudbeds_pms_v1_3.models.get_reservation_response_data_balance_detailed_inner.GetReservationResponse_data_balanceDetailed_inner(
                            suggested_deposit = '', 
                            sub_total = 1.337, 
                            additional_items = 1.337, 
                            taxes_fees = 1.337, 
                            grand_total = 1.337, 
                            paid = 1.337, )
                        ], 
                    assigned = [
                        cloudbeds_pms_v1_3.models.get_reservation_response_data_assigned_inner.GetReservationResponse_data_assigned_inner(
                            room_type_name = '', 
                            room_type_name_short = '', 
                            room_type_is_virtual = True, 
                            dorm_room_name = '', 
                            room_type_id = '', 
                            sub_reservation_id = '', 
                            room_name = '', 
                            room_id = '', 
                            start_date = datetime.datetime.strptime('1975-12-30', '%Y-%m-%d').date(), 
                            end_date = datetime.datetime.strptime('1975-12-30', '%Y-%m-%d').date(), 
                            adults = '', 
                            children = '', 
                            daily_rates = [
                                cloudbeds_pms_v1_3.models.get_reservation_response_data_assigned_inner_daily_rates_inner.GetReservationResponse_data_assigned_inner_dailyRates_inner(
                                    date = datetime.datetime.strptime('1975-12-30', '%Y-%m-%d').date(), 
                                    rate = 1.337, )
                                ], 
                            room_total = 1.337, )
                        ], 
                    unassigned = [
                        cloudbeds_pms_v1_3.models.get_reservation_response_data_unassigned_inner.GetReservationResponse_data_unassigned_inner(
                            room_type_name = '', 
                            room_type_is_virtual = True, 
                            room_type_id = '', 
                            sub_reservation_id = '', 
                            start_date = datetime.datetime.strptime('1975-12-30', '%Y-%m-%d').date(), 
                            end_date = datetime.datetime.strptime('1975-12-30', '%Y-%m-%d').date(), 
                            adults = '', 
                            children = '', 
                            room_total = 1.337, )
                        ], 
                    cards_on_file = [
                        cloudbeds_pms_v1_3.models.get_reservation_response_data_cards_on_file_inner.GetReservationResponse_data_cardsOnFile_inner(
                            card_id = '', 
                            card_number = '', 
                            card_type = 'visa', )
                        ], 
                    custom_fields = [
                        cloudbeds_pms_v1_3.models.get_reservation_response_data_guest_list_value_custom_fields_inner.GetReservationResponse_data_guestList_value_customFields_inner(
                            custom_field_name = '', 
                            custom_field_value = '', )
                        ], 
                    start_date = datetime.datetime.strptime('1975-12-30', '%Y-%m-%d').date(), 
                    end_date = datetime.datetime.strptime('1975-12-30', '%Y-%m-%d').date(), 
                    allotment_block_code = '', 
                    channel_provided_credit_card = True, 
                    group_inventory = [
                        cloudbeds_pms_v1_3.models.get_reservation_response_data_group_inventory_inner.GetReservationResponse_data_groupInventory_inner(
                            sub_reservation_id = '', 
                            allotment_block_code = '', 
                            start_date = datetime.datetime.strptime('1975-12-30', '%Y-%m-%d').date(), 
                            end_date = datetime.datetime.strptime('1975-12-30', '%Y-%m-%d').date(), )
                        ], 
                    origin = '', ),
                message = ''
            )
        else:
            return GetReservationResponse(
        )
        """

    def testGetReservationResponse(self):
        """Test GetReservationResponse"""
        # inst_req_only = self.make_instance(include_optional=False)
        # inst_req_and_optional = self.make_instance(include_optional=True)

if __name__ == '__main__':
    unittest.main()
