# coding: utf-8

"""
    Cloudbeds API

    <p>     Welcome to the documentation for <strong>Cloudbeds API Version v1.3</strong>!     If you are looking to learn how to use the Cloudbeds API to access guest information, reservations, or similar data     for your Cloudbeds customers, then you've come to the right place. </p>  <p>     In this document you will find all the API methods we provide along with explanations for parameters and response     examples. </p>  <p>     If you have questions about different implementation steps (e.g. how to implement OAuth 2.0), please refer to our     <a href=\"https://integrations.cloudbeds.com/hc/en-us\">Integrations Portal</a>. </p>  <p>     Be sure to <a href=\"https://go.pardot.com/l/308041/2018-07-24/qb2lg\">subscribe</a> to the monthly     Cloudbeds API announcement mailing list to receive information on new additions and improvements to the     Cloudbeds API and related developer tools. </p>  <p>     <strong>Endpoint:</strong> https://api.cloudbeds.com/api/v1.3/{method} </p>  <p>     <strong>HTTPS:</strong> Our API requires HTTPS. We'll respond with an appropriate error if you're not using it. </p>  <p>     <strong>Request Format:</strong> HTTP GET, POST and PUT (Content-Type: application/x-www-form-urlencoded) </p>  <p>     <strong>Response Format:</strong> JSON </p>  <p>     <strong>Response Header:</strong> X-Request-ID is added to response headers in all calls to help accelerate support     and troubleshooting. </p>  <p>     <strong>         <a href=\"https://integrations.cloudbeds.com/hc/en-us/articles/14104678058267-API-Documentation#postman-collection\">             <img src=\"https://run.pstmn.io/button.svg\" alt=\"Run in Postman\">         </a>     </strong> use this link to access our Public collection in Postman. </p>

    The version of the OpenAPI document: v1.3
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


import unittest

from cloudbeds_pms_v1_3.models.get_reservations_response import GetReservationsResponse

class TestGetReservationsResponse(unittest.TestCase):
    """GetReservationsResponse unit test stubs"""

    def setUp(self):
        pass

    def tearDown(self):
        pass

    def make_instance(self, include_optional) -> GetReservationsResponse:
        """Test GetReservationsResponse
            include_optional is a boolean, when False only required
            params are included, when True both required and
            optional params are included """
        # uncomment below to create an instance of `GetReservationsResponse`
        """
        model = GetReservationsResponse()
        if include_optional:
            return GetReservationsResponse(
                success = True,
                data = [
                    cloudbeds_pms_v1_3.models.get_reservations_response_data_inner.GetReservationsResponse_data_inner(
                        property_id = '', 
                        reservation_id = '', 
                        date_created = datetime.datetime.strptime('2013-10-20 19:20:30.00', '%Y-%m-%d %H:%M:%S.%f'), 
                        date_modified = datetime.datetime.strptime('2013-10-20 19:20:30.00', '%Y-%m-%d %H:%M:%S.%f'), 
                        status = 'not_confirmed', 
                        guest_id = '', 
                        profile_id = '', 
                        guest_name = '', 
                        start_date = datetime.datetime.strptime('1975-12-30', '%Y-%m-%d').date(), 
                        end_date = datetime.datetime.strptime('1975-12-30', '%Y-%m-%d').date(), 
                        allotment_block_code = '', 
                        adults = 56, 
                        children = 56, 
                        balance = 1.337, 
                        source_name = '', 
                        source_id = '', 
                        third_party_identifier = '', 
                        group_inventory = [
                            cloudbeds_pms_v1_3.models.get_reservation_response_data_group_inventory_inner.GetReservationResponse_data_groupInventory_inner(
                                sub_reservation_id = '', 
                                allotment_block_code = '', 
                                start_date = datetime.datetime.strptime('1975-12-30', '%Y-%m-%d').date(), 
                                end_date = datetime.datetime.strptime('1975-12-30', '%Y-%m-%d').date(), )
                            ], 
                        sub_reservation_id = '', 
                        custom_fields = [
                            cloudbeds_pms_v1_3.models.get_guests_modified_response_data_inner_custom_fields_inner.GetGuestsModifiedResponse_data_inner_customFields_inner(
                                custom_field_name = '', 
                                custom_field_value = '', )
                            ], 
                        rooms = [
                            cloudbeds_pms_v1_3.models.get_reservations_response_data_inner_rooms_inner.GetReservationsResponse_data_inner_rooms_inner(
                                room_type_id = '', 
                                room_type_name = '', 
                                room_type_is_virtual = True, 
                                sub_reservation_id = '', 
                                guest_id = '', 
                                guest_name = '', 
                                adults = '', 
                                children = '', 
                                room_id = '', 
                                room_name = '', 
                                room_check_in = '', 
                                room_check_out = '', 
                                room_status = 'cancelled', )
                            ], 
                        guest_list = {
                            'key' : cloudbeds_pms_v1_3.models.get_reservations_response_data_inner_guest_list_value.GetReservationsResponse_data_inner_guestList_value(
                                guest_id = '', 
                                guest_name = '', 
                                guest_first_name = '', 
                                guest_last_name = '', 
                                guest_gender = 'M', 
                                guest_email = '', 
                                guest_phone = '', 
                                guest_cell_phone = '', 
                                guest_address = '', 
                                guest_address2 = '', 
                                guest_city = '', 
                                guest_state = '', 
                                guest_country = '', 
                                guest_zip = '', 
                                guest_birthdate = datetime.datetime.strptime('1975-12-30', '%Y-%m-%d').date(), 
                                guest_document_type = '', 
                                guest_document_number = '', 
                                guest_document_issue_date = datetime.datetime.strptime('1975-12-30', '%Y-%m-%d').date(), 
                                guest_document_issuing_country = '', 
                                guest_document_expiration_date = datetime.datetime.strptime('1975-12-30', '%Y-%m-%d').date(), 
                                tax_id = '', 
                                company_tax_id = '', 
                                company_name = '', 
                                sub_reservation_id = '', 
                                start_date = datetime.datetime.strptime('1975-12-30', '%Y-%m-%d').date(), 
                                end_date = datetime.datetime.strptime('1975-12-30', '%Y-%m-%d').date(), 
                                assigned_room = '', 
                                room_id = '', 
                                room_name = '', 
                                room_type_name = '', 
                                room_type_is_virtual = True, 
                                unassigned_rooms = [
                                    cloudbeds_pms_v1_3.models.get_reservations_response_data_inner_guest_list_value_unassigned_rooms_inner.GetReservationsResponse_data_inner_guestList_value_unassignedRooms_inner(
                                        room_type_id = '', 
                                        room_type_name = '', 
                                        room_type_is_virtual = True, 
                                        room_type_name_short = '', 
                                        rate_id = '', 
                                        rate_plan_name = '', 
                                        sub_reservation_id = '', )
                                    ], 
                                is_anonymized = True, 
                                is_main_guest = True, )
                            }, 
                        origin = '', )
                    ],
                count = 56,
                total = 56
            )
        else:
            return GetReservationsResponse(
        )
        """

    def testGetReservationsResponse(self):
        """Test GetReservationsResponse"""
        # inst_req_only = self.make_instance(include_optional=False)
        # inst_req_and_optional = self.make_instance(include_optional=True)

if __name__ == '__main__':
    unittest.main()
